import { ref as E, computed as W, watch as ot, onMounted as it, onBeforeUnmount as ut, openBlock as a, createElementBlock as l, normalizeClass as ne, normalizeStyle as F, createBlock as Pe, unref as f, createSlots as nt, withCtx as ae, renderSlot as D, normalizeProps as J, guardReactiveProps as fe, createCommentVNode as p, toDisplayString as T, createElementVNode as _, Fragment as m, renderList as L, mergeProps as Ie, createVNode as ge, pushScopeId as rt, popScopeId as st } from "vue";
import { u as vt, c as dt, t as ct, a as ht, p as U, b as ft, F as gt, e as mt, d as Ee, m as pt, B as qe, X as xt, j as yt, k as me, n as Te, i as H, f as O, P as We, s as X, x as _e, y as Re } from "./index-C8SH0f2u.js";
import { t as kt, u as bt } from "./useResponsive-NZB-WLRF.js";
import Ae from "./BaseIcon-kBIAYqUO.js";
import { _ as St } from "./Tooltip--kgFEVZs.js";
import { u as wt, U as _t } from "./usePrinter-Dj50NAxo.js";
import { S as At } from "./Slicer-4nGKvUYF.js";
import Lt from "./vue-ui-skeleton-B4eWLjH3.js";
import { u as je } from "./useNestedProp-lS_T5lM3.js";
import { _ as zt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const A = {
  LINE: "LINE",
  BAR: "BAR",
  DONUT: "DONUT"
}, $t = ["SERIE", "SERIES", "DATA", "VALUE", "VALUES", "NUM"];
function Ct({ dataset: s, barLineSwitch: $ = 6 }) {
  let g = null, R = null, V = 0;
  if ((typeof s == "number" || typeof s == "string") && console.warn(`The provided dataset (${s}) is not sufficient to build a chart`), pe(s) && (Z(s) && (s.length < $ ? g = A.BAR : g = A.LINE, R = s, V = s.length), Le(s))) {
    if (!It(s))
      return console.warn("The objects in the dataset array have a different data structure. Either keys or value types are different."), !1;
    const oe = Object.keys(s[0]), re = Object.values(s[0]);
    if (!oe.some((P) => Et(P)))
      return console.warn("The data type of the dataset objects in the array must contain one of the following keys: DATA, SERIES, VALUE, VALUES, NUM. Casing is not important."), !1;
    Ge(re, (P) => typeof P == "number") && (g = A.DONUT, R = s), Ge(re, (P) => Array.isArray(P) && Z(P)) && (He(s) > $ ? g = A.LINE : g = A.BAR, V = He(s), R = s.map((P) => ({
      ...P,
      data: Tt(P, (G) => Z(G))
    }))), s = s.map((P) => Xe(P)), R = R.map((P) => Xe(P));
  }
  return pe(s) && [...new Set(s.flatMap((oe) => Array.isArray(oe)))][0], {
    dataset: s,
    type: g,
    usableDataset: R,
    maxSeriesLength: V
  };
}
function Ze(s) {
  return !s || pe(s) && !s.length;
}
function pe(s) {
  return Array.isArray(s);
}
function Z(s) {
  if (!pe(s) || Ze(s)) return !1;
  const $ = s.map((g) => Number(g));
  return ![...new Set($.flatMap((g) => typeof g == "number" && !isNaN(g)))].includes(!1);
}
function Le(s) {
  return !pe(s) || Ze(s) || !![...new Set(s.flatMap((g) => typeof g == "object" && !Array.isArray(g)))].includes(!1) ? !1 : !s.map((g) => Object.keys(g).length > 0).includes(!1);
}
function Pt(s, $) {
  const g = Object.keys(s).sort(), R = Object.keys($).sort();
  if (g.length !== R.length)
    return !1;
  for (let V = 0; V < g.length; V += 1) {
    const j = g[V], le = R[V];
    if (j !== le || typeof s[j] != typeof $[le])
      return !1;
  }
  return !0;
}
function It(s) {
  if (s.length <= 1) return !0;
  for (let $ = 0; $ < s.length; $ += 1)
    for (let g = $ + 1; g < s.length; g += 1)
      if (!Pt(s[$], s[g]))
        return !1;
  return !0;
}
function Et(s) {
  return $t.includes(s.toUpperCase());
}
function Ge(s, $) {
  let g = [];
  for (let R = 0; R < s.length; R += 1)
    g.push($(s[R]));
  return g.includes(!0);
}
function He(s) {
  return Math.max(...[...s].flatMap(($) => Object.values($).filter((g) => Z(g)).map((g) => g.length)));
}
function Tt(s, $) {
  return Object.values(s).filter((g) => $(g))[0];
}
function Xe(s) {
  const $ = {};
  for (let g in s)
    s.hasOwnProperty(g) && ($[g.toUpperCase()] = s[g]);
  return $;
}
const Ye = (s) => (rt("data-v-bf59d888"), s = s(), st(), s), Rt = ["id"], Nt = ["xmlns", "viewBox"], Ft = ["id"], Mt = ["id"], Ot = /* @__PURE__ */ Ye(() => /* @__PURE__ */ _("feColorMatrix", {
  type: "saturate",
  values: "0"
}, null, -1)), Bt = ["id"], Ut = ["flood-color"], Dt = {
  key: 0,
  class: "donut-label-connectors"
}, Vt = ["d", "stroke", "stroke-width", "filter"], qt = ["cx", "cy", "r", "fill"], Wt = ["cx", "cy", "r", "fill", "filter"], jt = { class: "donut" }, Gt = ["d", "fill", "stroke", "stroke-width", "filter"], Ht = ["d", "onMouseenter", "onClick"], Xt = {
  key: 1,
  class: "donut-labels quick-animation"
}, Zt = ["cx", "cy", "fill", "filter"], Yt = ["text-anchor", "x", "y", "fill", "font-size", "filter"], Jt = ["text-anchor", "x", "y", "fill", "font-size", "filter"], Qt = {
  key: 2,
  class: "donut-hollow quick-animation"
}, Kt = ["x", "y", "font-size", "fill"], ea = ["x", "y", "font-size", "fill"], ta = {
  key: 0,
  class: "line-grid"
}, aa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], la = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], oa = {
  key: 1,
  class: "line-axis"
}, ia = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], ua = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], na = {
  key: 2,
  class: "yLabels"
}, ra = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], sa = ["x", "y", "font-size", "fill"], va = {
  key: 3,
  class: "periodLabels"
}, da = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], ca = ["font-size", "text-anchor", "fill", "transform"], ha = { class: "plots" }, fa = { class: "line-plot-series" }, ga = ["d", "stroke", "stroke-width"], ma = ["d", "stroke", "stroke-width"], pa = ["d", "stroke", "stroke-width"], xa = ["d", "stroke", "stroke-width"], ya = ["cx", "cy", "fill", "stroke"], ka = {
  key: 4,
  class: "dataLabels"
}, ba = ["font-size", "fill", "x", "y"], Sa = { class: "tooltip-traps" }, wa = ["x", "y", "height", "width", "fill", "onMouseenter", "onClick"], _a = {
  key: 0,
  class: "line-grid"
}, Aa = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], La = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], za = {
  key: 1,
  class: "line-axis"
}, $a = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ca = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Pa = {
  key: 2,
  class: "yLabels"
}, Ia = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Ea = ["x", "y", "font-size", "fill"], Ta = {
  key: 3,
  class: "periodLabels"
}, Ra = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Na = ["font-size", "text-anchor", "transform", "fill"], Fa = { class: "plots" }, Ma = ["x", "width", "height", "y", "fill", "stroke", "stroke-width"], Oa = ["to"], Ba = ["from", "to"], Ua = {
  key: 4,
  class: "dataLabels"
}, Da = ["x", "y", "font-size", "fill"], Va = { class: "tooltip-traps" }, qa = ["x", "y", "height", "width", "fill", "onMouseenter", "onClick"], Wa = {
  key: 3,
  class: "axis-labels"
}, ja = { key: 0 }, Ga = ["font-size", "fill", "x", "y"], Ha = { key: 1 }, Xa = ["font-size", "fill", "x", "y"], Za = { key: 2 }, Ya = ["font-size", "fill", "transform"], Ja = { key: 3 }, Qa = ["font-size", "fill", "transform"], Ka = {
  key: 4,
  class: "vue-data-ui-watermark"
}, el = ["onClick"], tl = ["onClick"], al = ["onClick"], ll = {
  key: 1,
  class: "vue-ui-quick-chart-not-processable"
}, ol = /* @__PURE__ */ Ye(() => /* @__PURE__ */ _("span", null, "Dataset is not processable", -1)), il = {
  __name: "vue-ui-quick-chart",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: [Array, Object, String, Number],
      default() {
        return null;
      }
    }
  },
  emits: ["selectDatapoint", "selectLegend"],
  setup(s, { expose: $, emit: g }) {
    const R = s, { vue_ui_quick_chart: V } = vt(), j = E(null), le = E(null), oe = E(null), re = E(null), P = E(dt()), G = E(!1), se = E(null), Q = E(""), q = E(null), w = E([]), Ne = E(0), ze = E(0), e = W(() => {
      const r = je({
        userConfig: R.config,
        defaultConfig: V
      });
      return r.theme ? {
        ...je({
          userConfig: ct.vue_ui_quick_chart[r.theme] || R.config,
          defaultConfig: r
        }),
        customPalette: ht[r.theme] || U
      } : r;
    }), ve = W(() => ft(e.value.customPalette)), xe = W(() => {
      const r = Ct({ dataset: gt(R.dataset, [
        "serie",
        "series",
        "data",
        "value",
        "values",
        "num"
      ]), barLineSwitch: e.value.chartIsBarUnderDatasetLength });
      return r || console.error("VueUiQuickChart : Dataset is not processable"), r;
    }), k = E(xe.value), Je = W(() => !!k.value), z = W(() => k.value ? k.value.type : null);
    ot(() => z.value, (r) => {
      r || mt({
        componentName: "VueUiQuickChart",
        type: "dataset"
      });
    }, { immediate: !0 });
    const { isPrinting: ye, isImaging: ke, generatePdf: Fe, generateImage: Me } = wt({
      elementId: `${z.value}_${P.value}`,
      fileName: e.value.title || z.value
    }), b = E({
      width: e.value.width,
      height: e.value.height
    }), be = E({
      showTooltip: e.value.showTooltip
    }), Se = E(null);
    it(() => {
      if (e.value.responsive) {
        const r = kt(() => {
          const { width: c, height: t } = bt({
            chart: j.value,
            title: e.value.title ? le.value : null,
            legend: e.value.showLegend ? oe.value : null,
            slicer: [A.BAR, A.LINE].includes(z.value) && e.value.zoomXy && k.value.maxSeriesLength > 1 ? re.value : null
          });
          b.value.width = c, b.value.height = t;
        });
        Se.value = new ResizeObserver(r), Se.value.observe(j.value.parentNode);
      }
    }), ut(() => {
      Se.value && Se.value.disconnect();
    });
    const Qe = W(() => {
      switch (z.value) {
        case A.LINE:
          return `0 0 ${b.value.width <= 0 ? 10 : b.value.width} ${b.value.height <= 0 ? 10 : b.value.height}`;
        case A.BAR:
          return `0 0 ${b.value.width <= 0 ? 10 : b.value.width} ${b.value.height <= 0 ? 10 : b.value.height}`;
        case A.DONUT:
          return `0 0 ${b.value.width <= 0 ? 10 : b.value.width} ${b.value.height <= 0 ? 10 : b.value.height}`;
        default:
          return `0 0 ${b.value.width <= 0 ? 10 : b.value.width} ${b.value.height <= 0 ? 10 : b.value.height}`;
      }
    });
    function Oe(r) {
      return [...r].map((c) => c.value).reduce((c, t) => c + t, 0);
    }
    function de(r) {
      return e.value.blurOnHover && ![null, void 0].includes(q.value) && q.value !== r ? `url(#blur_${P.value})` : "";
    }
    function Be(r, c) {
      w.value.includes(r) ? w.value = w.value.filter((t) => t !== r) : w.value.length < c && w.value.push(r);
    }
    const Ue = E(null), De = E(null), we = E(!1);
    function Ke(r, c) {
      we.value = !0;
      let t = r.value;
      if (w.value.includes(r.id)) {
        let n = function() {
          t > u ? (we.value = !1, cancelAnimationFrame(De.value), k.value = {
            ...k.value,
            dataset: k.value.dataset.map((h, N) => r.id === `donut_${N}` ? {
              ...h,
              value: u,
              VALUE: u
            } : h)
          }) : (t += u * 0.025, k.value = {
            ...k.value,
            dataset: k.value.dataset.map((h, N) => r.id === `donut_${N}` ? {
              ...h,
              value: t,
              VALUE: t
            } : h)
          }, De.value = requestAnimationFrame(n));
        };
        w.value = w.value.filter((h) => h !== r.id);
        const u = xe.value.dataset.find((h, N) => r.id === `donut_${N}`).VALUE;
        n();
      } else if (c.length > 1) {
        let u = function() {
          t < 0.1 ? (we.value = !1, cancelAnimationFrame(Ue.value), w.value.push(r.id), k.value = {
            ...k.value,
            dataset: k.value.dataset.map((n, h) => r.id === `donut_${h}` ? {
              ...n,
              value: 0,
              VALUE: 0
            } : n)
          }) : (t /= 1.1, k.value = {
            ...k.value,
            dataset: k.value.dataset.map((n, h) => r.id === `donut_${h}` ? {
              ...n,
              value: t,
              VALUE: t
            } : n)
          }, Ue.value = requestAnimationFrame(u));
        };
        u();
      }
    }
    const Y = E(null);
    function et(r) {
      Y.value = r;
    }
    const C = W(() => {
      if (z.value !== A.DONUT) return null;
      const r = k.value.dataset.map((o, i) => ({
        ...o,
        value: o.VALUE || o.DATA || o.SERIE || o.VALUES || o.NUM || 0,
        name: o.NAME || o.DESCRIPTION || o.TITLE || o.LABEL || `Serie ${i}`,
        id: `donut_${i}`
      })).map((o, i) => ({
        ...o,
        color: o.COLOR ? Ee(o.COLOR) : ve.value[i + e.value.paletteStartIndex] || U[i + e.value.paletteStartIndex] || U[(i + e.value.paletteStartIndex) % U.length],
        immutableValue: o.value
      }));
      function c(o, i) {
        return O({
          v: isNaN(o.value / Oe(i)) ? 0 : o.value / Oe(i) * 100,
          s: "%",
          r: e.value.dataLabelRoundingPercentage
        });
      }
      function t(o) {
        return o.proportion * 100 > e.value.donutHideLabelUnderPercentage;
      }
      function u(o, i) {
        const y = xe.value.dataset.find((I, M) => `donut_${M}` === o).VALUE;
        return Math.abs(String(Number(y.toFixed(0))).length - String(Number(i.toFixed(0))).length);
      }
      function n({ datapoint: o, seriesIndex: i }) {
        se.value = { datapoint: o, seriesIndex: i, config: e.value, dataset: r }, q.value = o.id;
        const y = e.value.tooltipCustomFormat;
        if (_e(y) && Re(() => y({
          datapoint: o,
          seriesIndex: i,
          series: r,
          config: e.value
        })))
          Q.value = y({
            datapoint: o,
            seriesIndex: i,
            series: r,
            config: e.value
          });
        else {
          let x = "";
          x += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.tooltipBorderColor};padding-bottom:6px;margin-bottom:3px;">${o.name}</div>`, x += `<div style="display:flex;flex-direction:row;gap:6px;align-items:center;"><svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="none" fill="${o.color}"/></svg>`, x += `<b>${H(
            e.value.formatter,
            o.value,
            O({
              p: e.value.valuePrefix,
              v: o.value,
              s: e.value.valueSuffix,
              r: e.value.dataLabelRoundingValue
            }),
            { datapoint: o, seriesIndex: i }
          )}</b>`, x += `<span>(${O({ v: o.proportion * 100, s: "%", r: e.value.dataLabelRoundingPercentage })})</span></div>`, Q.value = `<div>${x}</div>`;
        }
        G.value = !0;
      }
      function h() {
        G.value = !1, q.value = null, Y.value = null;
      }
      const N = {
        centerX: b.value.width / 2,
        centerY: b.value.height / 2
      }, B = r.filter((o) => !w.value.includes(o.id)).map((o) => o.value || 0).reduce((o, i) => o + i, 0), ie = r.map((o, i) => ({
        ...o,
        proportion: (o.value || 0) / B,
        value: o.value || 0,
        absoluteValue: xe.value.dataset.find((y, x) => `donut_${x}` === o.id).VALUE
      })), K = b.value.width / 2, ue = b.value.height / 2, ee = b.value.height * e.value.donutRadiusRatio;
      return {
        dataset: ie.filter((o) => !w.value.includes(o.id)),
        legend: ie,
        drawingArea: N,
        displayArcPercentage: c,
        isArcBigEnough: t,
        useTooltip: n,
        killTooltip: h,
        getSpaces: u,
        total: B,
        cx: K,
        cy: ue,
        radius: ee,
        chart: pt(
          { series: r.filter((o) => !w.value.includes(o.id)) },
          K,
          ue,
          ee,
          ee,
          1.99999,
          2,
          1,
          360,
          105.25,
          b.value.height * e.value.donutThicknessRatio
        )
      };
    }), S = E({
      start: 0,
      end: k.value.maxSeriesLength
    });
    function tt() {
      S.value = {
        start: 0,
        end: k.value.maxSeriesLength
      }, ze.value += 1;
    }
    const at = W(() => {
      if (!e.value.zoomMinimap.show || z.value === A.DONUT) return [];
      let r = [];
      Z(k.value.dataset) && (r = k.value.dataset), Le(k.value.dataset) && (r = k.value.dataset.map((n, h) => ({
        values: n.VALUE || n.DATA || n.SERIE || n.SERIES || n.VALUES || n.NUM || 0,
        id: z.value === A.LINE ? `line_${h}` : `bar_${h}`
      })).filter((n) => !w.value.includes(n.id)));
      const c = Z(r) ? r.length : Math.max(...r.map((n) => n.values.length));
      let t = [];
      if (Z(r))
        t = r;
      else
        for (let n = 0; n < c; n += 1)
          t.push(r.map((h) => h.values[n] || 0).reduce((h, N) => (h || 0) + (N || 0), 0));
      const u = Math.min(...t);
      return t.map((n) => n + (u < 0 ? Math.abs(u) : 0));
    }), d = W(() => {
      if (z.value !== A.LINE) return null;
      const r = {
        height: b.value.height,
        width: b.value.width
      }, c = {
        left: e.value.xyPaddingLeft,
        top: e.value.xyPaddingTop,
        right: r.width - e.value.xyPaddingRight,
        bottom: r.height - e.value.xyPaddingBottom,
        width: r.width - e.value.xyPaddingLeft - e.value.xyPaddingRight,
        height: r.height - e.value.xyPaddingTop - e.value.xyPaddingBottom
      };
      let t = [];
      Z(k.value.dataset) && (t = [
        {
          values: k.value.dataset.slice(S.value.start, S.value.end),
          absoluteIndices: k.value.dataset.map((o, i) => i).slice(S.value.start, S.value.end),
          name: e.value.title,
          color: ve.value[e.value.paletteStartIndex] || U[e.value.paletteStartIndex],
          id: "line_0"
        }
      ]), Le(k.value.dataset) && (t = k.value.dataset.map((o, i) => ({
        ...o,
        values: o.VALUE || o.DATA || o.SERIE || o.SERIES || o.VALUES || o.NUM || 0,
        name: o.NAME || o.DESCRIPTION || o.TITLE || o.LABEL || `Serie ${i}`,
        id: `line_${i}`
      })).map((o, i) => ({
        ...o,
        color: o.COLOR ? Ee(o.COLOR) : ve.value[i + e.value.paletteStartIndex] || U[i + e.value.paletteStartIndex] || U[(i + e.value.paletteStartIndex) % U.length],
        values: o.values.slice(S.value.start, S.value.end),
        absoluteIndices: o.values.map((y, x) => x).slice(S.value.start, S.value.end)
      })));
      const u = {
        max: Math.max(...t.filter((o) => !w.value.includes(o.id)).flatMap((o) => o.values)),
        min: Math.min(...t.filter((o) => !w.value.includes(o.id)).flatMap((o) => o.values)),
        maxSeries: Math.max(...t.map((o) => o.values.length))
      }, n = qe(u.min < 0 ? u.min : 0, u.max < 0 ? 0 : u.max, e.value.xyScaleSegments), h = u.min < 0 ? Math.abs(u.min) : 0, N = u.max < 0 ? c.top : c.bottom - h / (n.max + h) * c.height, B = c.width / u.maxSeries, ie = n.ticks.map((o) => ({
        y: c.bottom - c.height * ((o + h) / (n.max + h)),
        x: c.left - 8,
        value: o
      })), K = t.map((o, i) => ({
        ...o,
        coordinates: o.values.map((y, x) => ({
          x: c.left + B * (x + 1) - B / 2,
          y: c.bottom - (y + h) / (n.max + h) * c.height,
          value: y
        }))
      })).map((o) => {
        let i = [];
        return o.coordinates.forEach((y) => {
          i.push(`${y.x},${y.y} `);
        }), {
          ...o,
          linePath: i.join(" ")
        };
      });
      function ue(o) {
        q.value = o, Y.value = o;
        const i = t.map((x) => ({
          ...x,
          value: x.values[o],
          absoluteIndex: x.absoluteIndices[o]
        })).filter((x) => !w.value.includes(x.id));
        se.value = { datapoint: i, seriesIndex: o, config: e.value, dataset: t };
        const y = e.value.tooltipCustomFormat;
        if (_e(y) && Re(() => y({
          datapoint: i,
          seriesIndex: o,
          series: t,
          config: e.value
        })))
          Q.value = y({
            datapoint: i,
            seriesIndex: o,
            series: t,
            config: e.value
          });
        else {
          let x = "";
          e.value.xyPeriods[i[0].absoluteIndex] && (x += `<div style="border-bottom:1px solid ${e.value.tooltipBorderColor};padding-bottom:6px;margin-bottom:3px;">${e.value.xyPeriods[i[0].absoluteIndex]}</div>`), i.forEach((I, M) => {
            x += `
                    <div style="display:flex; flex-wrap: wrap; align-items:center; gap:3px;">
                        <svg viewBox="0 0 12 12" height="14" width="12"><circle cx="6" cy="6" r="6" stroke="none" fill="${I.color}"/></svg>
                        <span>${I.name}:</span>
                        <b>${H(
              e.value.formatter,
              I.value,
              O({
                p: e.value.valuePrefix,
                v: I.value,
                s: e.value.valueSuffix,
                r: e.value.dataLabelRoundingValue
              }),
              { datapoint: I, seriesIndex: M }
            )}
                        </b>
                    </div>
                `;
          }), Q.value = x;
        }
        G.value = !0;
      }
      function ee() {
        q.value = null, G.value = !1;
      }
      return {
        absoluteZero: N,
        dataset: K.filter((o) => !w.value.includes(o.id)),
        legend: K,
        drawingArea: c,
        extremes: u,
        slotSize: B,
        yLabels: ie,
        useTooltip: ue,
        killTooltip: ee
      };
    }), v = W(() => {
      if (z.value !== A.BAR) return null;
      const r = {
        height: b.value.height,
        width: b.value.width
      }, c = {
        left: e.value.xyPaddingLeft,
        top: e.value.xyPaddingTop,
        right: r.width - e.value.xyPaddingRight,
        bottom: r.height - e.value.xyPaddingBottom,
        width: r.width - e.value.xyPaddingLeft - e.value.xyPaddingRight,
        height: r.height - e.value.xyPaddingTop - e.value.xyPaddingBottom
      };
      let t = [];
      Z(k.value.dataset) && (t = [
        {
          values: k.value.dataset.slice(S.value.start, S.value.end),
          absoluteIndices: k.value.dataset.map((i, y) => y).slice(S.value.start, S.value.end),
          name: e.value.title,
          color: ve.value[e.value.paletteStartIndex] || U[e.value.paletteStartIndex],
          id: "bar_0"
        }
      ]), Le(k.value.dataset) && (t = k.value.dataset.map((i, y) => ({
        ...i,
        values: i.VALUE || i.DATA || i.SERIE || i.SERIES || i.VALUES || i.NUM || 0,
        name: i.NAME || i.DESCRIPTION || i.TITLE || i.LABEL || `Serie ${y}`,
        id: `bar_${y}`
      })).map((i, y) => ({
        ...i,
        color: i.COLOR ? Ee(i.COLOR) : ve.value[y + e.value.paletteStartIndex] || U[y + e.value.paletteStartIndex] || U[(y + e.value.paletteStartIndex) % U.length],
        values: i.values.slice(S.value.start, S.value.end),
        absoluteIndices: i.values.map((x, I) => I).slice(S.value.start, S.value.end)
      })));
      const u = {
        max: Math.max(...t.filter((i) => !w.value.includes(i.id)).flatMap((i) => i.values)) < 0 ? 0 : Math.max(...t.filter((i) => !w.value.includes(i.id)).flatMap((i) => i.values)),
        min: Math.min(...t.filter((i) => !w.value.includes(i.id)).flatMap((i) => i.values)),
        maxSeries: Math.max(...t.filter((i) => !w.value.includes(i.id)).map((i) => i.values.length))
      }, n = qe(u.min < 0 ? u.min : 0, u.max, e.value.xyScaleSegments), h = n.min < 0 ? Math.abs(n.min) : 0, N = c.bottom - h / (n.max + h) * c.height, B = c.width / u.maxSeries, ie = n.ticks.map((i) => ({
        y: c.bottom - c.height * ((i + h) / (n.max + h)),
        x: c.left - 8,
        value: i
      })), K = t.map((i, y) => ({
        ...i,
        coordinates: i.values.map((x, I) => {
          const M = (x + h) / (u.max + h) * c.height, ce = Math.abs(x) / Math.abs(u.min) * (c.height - N), Ce = h / (u.max + h) * c.height, he = B / t.filter((te) => !w.value.includes(te.id)).length - e.value.barGap / t.filter((te) => !w.value.includes(te.id)).length;
          return {
            x: c.left + B * I + he * y + e.value.barGap / 2,
            y: x > 0 ? c.bottom - M : N,
            height: x > 0 ? M - Ce : ce,
            value: x,
            width: he
          };
        })
      })), ue = t.filter((i) => !w.value.includes(i.id)).map((i, y) => ({
        ...i,
        coordinates: i.values.map((x, I) => {
          const M = (x + h) / (u.max + h) * c.height, ce = Math.abs(x) / (u.max + h) * c.height, Ce = h / (u.max + h) * c.height, he = B / t.filter((te) => !w.value.includes(te.id)).length - e.value.barGap / t.filter((te) => !w.value.includes(te.id)).length;
          return {
            x: c.left + B * I + he * y + e.value.barGap / 2,
            y: x > 0 ? c.bottom - M : N,
            height: x > 0 ? M - Ce : ce,
            value: x,
            width: he
          };
        })
      }));
      function ee(i) {
        q.value = i, Y.value = i;
        const y = t.map((I) => ({
          ...I,
          value: I.values[i],
          absoluteIndex: I.absoluteIndices[i]
        })).filter((I) => !w.value.includes(I.id));
        se.value = { datapoint: y, seriesIndex: i, config: e.value, dataset: t };
        const x = e.value.tooltipCustomFormat;
        if (_e(x) && Re(() => x({
          datapoint: y,
          seriesIndex: i,
          series: t,
          config: e.value
        })))
          Q.value = x({
            point: y,
            seriesIndex: i,
            series: t,
            config: e.value
          });
        else {
          let I = "";
          e.value.xyPeriods[y[0].absoluteIndex] && (I += `<div style="border-bottom:1px solid ${e.value.tooltipBorderColor};padding-bottom:6px;margin-bottom:3px;">${e.value.xyPeriods[y[0].absoluteIndex]}</div>`), y.forEach((M, ce) => {
            I += `
                    <div style="display:flex; flex-wrap: wrap; align-items:center; gap:3px;">
                        <svg viewBox="0 0 12 12" height="14" width="12"><rect x=0 y="0" width="12" height="12" rx="1" stroke="none" fill="${M.color}"/></svg>
                        <span>${M.name}:</span>
                        <b>${H(
              e.value.formatter,
              M.value,
              O({
                p: e.value.valuePrefix,
                v: M.value,
                s: e.value.valueSuffix,
                r: e.value.dataLabelRoundingValue
              }),
              { datapoint: M, seriesIndex: ce }
            )}
                        </b>
                    </div>
                `;
          }), Q.value = I;
        }
        G.value = !0;
      }
      function o() {
        G.value = !1, q.value = null, Y.value = null;
      }
      return {
        absoluteZero: N,
        dataset: ue.filter((i) => !w.value.includes(i.id)),
        legend: K,
        drawingArea: c,
        extremes: u,
        slotSize: B,
        yLabels: ie,
        useTooltip: ee,
        killTooltip: o
      };
    }), $e = E(!1);
    function lt(r) {
      $e.value = r, Ne.value += 1;
    }
    function Ve() {
      be.value.showTooltip = !be.value.showTooltip;
    }
    return $({
      generatePdf: Fe,
      generateImage: Me,
      toggleTooltip: Ve
    }), (r, c) => Je.value ? (a(), l("div", {
      key: 0,
      id: `${z.value}_${P.value}`,
      ref_key: "quickChart",
      ref: j,
      class: ne({ "vue-ui-quick-chart": !0, "vue-data-ui-wrapper-fullscreen": $e.value }),
      style: F(`background:${e.value.backgroundColor};color:${e.value.color};font-family:${e.value.fontFamily}; position: relative; ${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.showUserOptions ? (a(), Pe(_t, {
        ref: "details",
        key: `user_option_${Ne.value}`,
        backgroundColor: e.value.backgroundColor,
        color: e.value.color,
        isPrinting: f(ye),
        isImaging: f(ke),
        uid: P.value,
        hasTooltip: e.value.userOptionsButtons.tooltip && e.value.showTooltip,
        hasPdf: e.value.userOptionsButtons.pdf,
        hasImg: e.value.userOptionsButtons.img,
        hasFullscreen: e.value.userOptionsButtons.fullscreen,
        hasXls: !1,
        isTooltip: be.value.showTooltip,
        isFullscreen: $e.value,
        titles: { ...e.value.userOptionsButtonTitles },
        chartElement: j.value,
        onToggleFullscreen: lt,
        onGeneratePdf: f(Fe),
        onGenerateImage: f(Me),
        onToggleTooltip: Ve
      }, nt({ _: 2 }, [
        r.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: ae(() => [
            D(r.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        r.$slots.optionPdf ? {
          name: "optionPdf",
          fn: ae(() => [
            D(r.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        r.$slots.optionImg ? {
          name: "optionImg",
          fn: ae(() => [
            D(r.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        r.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: ae(({ toggleFullscreen: t, isFullscreen: u }) => [
            D(r.$slots, "optionFullscreen", J(fe({ toggleFullscreen: t, isFullscreen: u })), void 0, !0)
          ]),
          key: "3"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasImg", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : p("", !0),
      e.value.title ? (a(), l("div", {
        key: 1,
        ref_key: "quickChartTitle",
        ref: le,
        class: "vue-ui-quick-chart-title",
        style: F(`background:${e.value.backgroundColor};color:${e.value.color};font-size:${e.value.titleFontSize}px;font-weight:${e.value.titleBold ? "bold" : "normal"};text-align:${e.value.titleTextAlign}`)
      }, T(e.value.title), 5)) : p("", !0),
      z.value ? (a(), l("svg", {
        key: 2,
        xmlns: f(xt),
        viewBox: Qe.value,
        style: F(`max-width:100%;overflow:visible;background:${e.value.backgroundColor};color:${e.value.color}`)
      }, [
        _("defs", null, [
          _("filter", {
            id: `blur_${P.value}`,
            x: "-50%",
            y: "-50%",
            width: "200%",
            height: "200%"
          }, [
            _("feGaussianBlur", {
              in: "SourceGraphic",
              stdDeviation: 2,
              id: `blur_std_${P.value}`
            }, null, 8, Mt),
            Ot
          ], 8, Ft),
          _("filter", {
            id: `shadow_${P.value}`,
            "color-interpolation-filters": "sRGB"
          }, [
            _("feDropShadow", {
              dx: "0",
              dy: "0",
              stdDeviation: "10",
              "flood-opacity": "0.5",
              "flood-color": e.value.donutShadowColor
            }, null, 8, Ut)
          ], 8, Bt)
        ]),
        z.value === A.DONUT ? (a(), l(m, { key: 0 }, [
          e.value.showDataLabels ? (a(), l("g", Dt, [
            (a(!0), l(m, null, L(C.value.chart, (t, u) => (a(), l(m, null, [
              C.value.isArcBigEnough(t) ? (a(), l("path", {
                key: 0,
                d: f(yt)(t, { x: (e.value.width || b.value.width) / 2, y: (e.value.height || b.value.height) / 2 }, 16, 16, !1, !1, e.value.donutLabelMarkerStrokeWidth),
                stroke: t.color,
                "stroke-width": e.value.donutLabelMarkerStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none",
                filter: de(t.id)
              }, null, 8, Vt)) : p("", !0)
            ], 64))), 256))
          ])) : p("", !0),
          _("circle", {
            class: "donut-hollow",
            cx: (e.value.width || b.value.width) / 2,
            cy: (e.value.height || b.value.height) / 2,
            r: (e.value.height || b.value.height) * e.value.donutRadiusRatio,
            fill: e.value.backgroundColor
          }, null, 8, qt),
          _("circle", {
            cx: C.value.cx,
            cy: C.value.cy,
            r: C.value.radius,
            fill: e.value.backgroundColor,
            filter: e.value.donutUseShadow ? `url(#shadow_${P.value})` : ""
          }, null, 8, Wt),
          _("g", jt, [
            (a(!0), l(m, null, L(C.value.chart, (t, u) => (a(), l("path", {
              d: t.arcSlice,
              fill: t.color,
              stroke: e.value.backgroundColor,
              "stroke-width": e.value.donutStrokeWidth,
              filter: de(t.id)
            }, null, 8, Gt))), 256)),
            (a(!0), l(m, null, L(C.value.chart, (t, u) => (a(), l("path", {
              d: t.arcSlice,
              fill: "transparent",
              onMouseenter: (n) => C.value.useTooltip({ datapoint: t, seriesIndex: u }),
              onMouseout: c[0] || (c[0] = (n) => C.value.killTooltip()),
              onClick: (n) => g("selectDatapoint", t)
            }, null, 40, Ht))), 256))
          ]),
          e.value.showDataLabels ? (a(), l("g", Xt, [
            (a(!0), l(m, null, L(C.value.chart, (t, u) => (a(), l(m, null, [
              C.value.isArcBigEnough(t) ? (a(), l("circle", {
                key: 0,
                cx: f(me)(t).x,
                cy: f(Te)(t) - 3.7,
                fill: t.color,
                r: 3,
                filter: de(t.id)
              }, null, 8, Zt)) : p("", !0),
              C.value.isArcBigEnough(t) ? (a(), l("text", {
                key: 1,
                "text-anchor": f(me)(t, !0, 20).anchor,
                x: f(me)(t, !0).x,
                y: f(Te)(t),
                fill: e.value.color,
                "font-size": e.value.dataLabelFontSize,
                filter: de(t.id)
              }, T(C.value.displayArcPercentage(t, C.value.chart)) + " (" + T(f(H)(
                e.value.formatter,
                t.value,
                f(O)({
                  p: e.value.valuePrefix,
                  v: t.value,
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: t, seriesIndex: u }
              )) + ") ", 9, Yt)) : p("", !0),
              C.value.isArcBigEnough(t, !0, 20) ? (a(), l("text", {
                key: 2,
                "text-anchor": f(me)(t).anchor,
                x: f(me)(t, !0).x,
                y: f(Te)(t) + e.value.dataLabelFontSize,
                fill: e.value.color,
                "font-size": e.value.dataLabelFontSize,
                filter: de(t.id)
              }, T(t.name), 9, Jt)) : p("", !0)
            ], 64))), 256))
          ])) : p("", !0),
          e.value.donutShowTotal ? (a(), l("g", Qt, [
            _("text", {
              "text-anchor": "middle",
              x: C.value.drawingArea.centerX,
              y: C.value.drawingArea.centerY - e.value.donutTotalLabelFontSize / 2,
              "font-size": e.value.donutTotalLabelFontSize,
              fill: e.value.color
            }, T(e.value.donutTotalLabelText), 9, Kt),
            _("text", {
              "text-anchor": "middle",
              x: C.value.drawingArea.centerX,
              y: C.value.drawingArea.centerY + e.value.donutTotalLabelFontSize,
              "font-size": e.value.donutTotalLabelFontSize,
              fill: e.value.color
            }, T(f(O)({
              p: e.value.valuePrefix,
              v: C.value.total,
              s: e.value.valueSuffix,
              r: e.value.dataLabelRoundingValue
            })), 9, ea)
          ])) : p("", !0)
        ], 64)) : p("", !0),
        z.value === A.LINE ? (a(), l(m, { key: 1 }, [
          e.value.xyShowGrid ? (a(), l("g", ta, [
            (a(!0), l(m, null, L(d.value.yLabels, (t) => (a(), l(m, null, [
              t.y <= d.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: d.value.drawingArea.left,
                x2: d.value.drawingArea.right,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyGridStroke,
                "stroke-width": e.value.xyGridStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, aa)) : p("", !0)
            ], 64))), 256)),
            (a(!0), l(m, null, L(d.value.extremes.maxSeries + 1, (t, u) => (a(), l("line", {
              x1: d.value.drawingArea.left + d.value.slotSize * u,
              x2: d.value.drawingArea.left + d.value.slotSize * u,
              y1: d.value.drawingArea.top,
              y2: d.value.drawingArea.bottom,
              stroke: e.value.xyGridStroke,
              "stroke-width": e.value.xyGridStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, la))), 256))
          ])) : p("", !0),
          e.value.xyShowAxis ? (a(), l("g", oa, [
            _("line", {
              x1: d.value.drawingArea.left,
              x2: d.value.drawingArea.left,
              y1: d.value.drawingArea.top,
              y2: d.value.drawingArea.bottom,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, ia),
            _("line", {
              x1: d.value.drawingArea.left,
              x2: d.value.drawingArea.right,
              y1: isNaN(d.value.absoluteZero) ? d.value.drawingArea.bottom : d.value.absoluteZero,
              y2: isNaN(d.value.absoluteZero) ? d.value.drawingArea.bottom : d.value.absoluteZero,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, ua)
          ])) : p("", !0),
          e.value.xyShowScale ? (a(), l("g", na, [
            (a(!0), l(m, null, L(d.value.yLabels, (t, u) => (a(), l(m, null, [
              t.y <= d.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: t.x + 4,
                x2: d.value.drawingArea.left,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyAxisStroke,
                "stroke-width": e.value.xyAxisStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, ra)) : p("", !0),
              t.y <= d.value.drawingArea.bottom ? (a(), l("text", {
                key: 1,
                x: t.x,
                y: t.y + e.value.xyLabelsYFontSize / 3,
                "text-anchor": "end",
                "font-size": e.value.xyLabelsYFontSize,
                fill: e.value.color
              }, T(f(H)(
                e.value.formatter,
                t.value,
                f(O)({
                  p: e.value.valuePrefix,
                  v: t.value,
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: t, seriesIndex: u }
              )), 9, sa)) : p("", !0)
            ], 64))), 256))
          ])) : p("", !0),
          e.value.xyShowScale && e.value.xyPeriods.length ? (a(), l("g", va, [
            (a(!0), l(m, null, L(e.value.xyPeriods.slice(S.value.start, S.value.end), (t, u) => (a(), l("line", {
              x1: d.value.drawingArea.left + d.value.slotSize * (u + 1) - d.value.slotSize / 2,
              x2: d.value.drawingArea.left + d.value.slotSize * (u + 1) - d.value.slotSize / 2,
              y1: d.value.drawingArea.bottom,
              y2: d.value.drawingArea.bottom + 4,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, da))), 256)),
            (a(!0), l(m, null, L(e.value.xyPeriods.slice(S.value.start, S.value.end), (t, u) => (a(), l("text", {
              "font-size": e.value.xyLabelsXFontSize,
              "text-anchor": e.value.xyPeriodLabelsRotation > 0 ? "start" : e.value.xyPeriodLabelsRotation < 0 ? "end" : "middle",
              fill: e.value.color,
              transform: `translate(${d.value.drawingArea.left + d.value.slotSize * (u + 1) - d.value.slotSize / 2}, ${d.value.drawingArea.bottom + e.value.xyLabelsXFontSize + 6}), rotate(${e.value.xyPeriodLabelsRotation})`
            }, T(t), 9, ca))), 256))
          ])) : p("", !0),
          _("g", ha, [
            (a(!0), l(m, null, L(d.value.dataset, (t, u) => (a(), l("g", fa, [
              e.value.lineSmooth ? (a(), l(m, { key: 0 }, [
                _("path", {
                  d: `M ${f(We)(t.coordinates)}`,
                  stroke: e.value.backgroundColor,
                  "stroke-width": e.value.lineStrokeWidth + 1,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, ga),
                _("path", {
                  d: `M ${f(We)(t.coordinates)}`,
                  stroke: t.color,
                  "stroke-width": e.value.lineStrokeWidth,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, ma)
              ], 64)) : (a(), l(m, { key: 1 }, [
                _("path", {
                  d: `M ${t.linePath}`,
                  stroke: e.value.backgroundColor,
                  "stroke-width": e.value.lineStrokeWidth + 1,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, pa),
                _("path", {
                  d: `M ${t.linePath}`,
                  stroke: t.color,
                  "stroke-width": e.value.lineStrokeWidth,
                  "stroke-linecap": "round",
                  fill: "none",
                  class: ne({ "quick-animation": !0, "vue-data-ui-line-animated": e.value.lineAnimated }),
                  style: { transition: "all 0.3s ease-in-out" }
                }, null, 10, xa)
              ], 64)),
              (a(!0), l(m, null, L(t.coordinates, (n, h) => (a(), l("circle", {
                cx: n.x,
                cy: f(X)(n.y),
                r: 3,
                fill: t.color,
                stroke: e.value.backgroundColor,
                "stroke-width": "0.5",
                class: "quick-animation",
                style: { transition: "all 0.3s ease-in-out" }
              }, null, 8, ya))), 256))
            ]))), 256))
          ]),
          e.value.showDataLabels ? (a(), l("g", ka, [
            (a(!0), l(m, null, L(d.value.dataset, (t, u) => (a(), l(m, null, [
              (a(!0), l(m, null, L(t.coordinates, (n, h) => (a(), l("text", {
                "text-anchor": "middle",
                "font-size": e.value.dataLabelFontSize,
                fill: t.color,
                x: n.x,
                y: f(X)(n.y) - e.value.dataLabelFontSize / 2,
                class: "quick-animation",
                style: { transition: "all 0.3s ease-in-out" }
              }, T(f(H)(
                e.value.formatter,
                f(X)(n.value),
                f(O)({
                  p: e.value.valuePrefix,
                  v: f(X)(n.value),
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: n, seriesIndex: h }
              )), 9, ba))), 256))
            ], 64))), 256))
          ])) : p("", !0),
          _("g", Sa, [
            (a(!0), l(m, null, L(d.value.extremes.maxSeries, (t, u) => (a(), l("rect", {
              x: d.value.drawingArea.left + u * d.value.slotSize,
              y: d.value.drawingArea.top,
              height: d.value.drawingArea.height <= 0 ? 1e-5 : d.value.drawingArea.height,
              width: d.value.slotSize <= 0 ? 1e-5 : d.value.slotSize,
              fill: [q.value, Y.value].includes(u) ? e.value.xyHighlighterColor : "transparent",
              style: F(`opacity:${e.value.xyHighlighterOpacity}`),
              onMouseenter: (n) => d.value.useTooltip(u),
              onMouseleave: c[1] || (c[1] = (n) => d.value.killTooltip()),
              onClick: (n) => g("selectDatapoint", d.value.dataset.map((h) => ({
                ...h,
                value: h.values[u]
              })))
            }, null, 44, wa))), 256))
          ])
        ], 64)) : p("", !0),
        z.value === A.BAR ? (a(), l(m, { key: 2 }, [
          e.value.xyShowGrid ? (a(), l("g", _a, [
            (a(!0), l(m, null, L(v.value.yLabels, (t) => (a(), l(m, null, [
              t.y <= v.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: v.value.drawingArea.left,
                x2: v.value.drawingArea.right,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyGridStroke,
                "stroke-width": e.value.xyGridStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, Aa)) : p("", !0)
            ], 64))), 256)),
            (a(!0), l(m, null, L(v.value.extremes.maxSeries + 1, (t, u) => (a(), l("line", {
              x1: v.value.drawingArea.left + v.value.slotSize * u,
              x2: v.value.drawingArea.left + v.value.slotSize * u,
              y1: v.value.drawingArea.top,
              y2: v.value.drawingArea.bottom,
              stroke: e.value.xyGridStroke,
              "stroke-width": e.value.xyGridStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, La))), 256))
          ])) : p("", !0),
          e.value.xyShowAxis ? (a(), l("g", za, [
            _("line", {
              x1: v.value.drawingArea.left,
              x2: v.value.drawingArea.left,
              y1: v.value.drawingArea.top,
              y2: v.value.drawingArea.bottom,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, $a),
            _("line", {
              x1: v.value.drawingArea.left,
              x2: v.value.drawingArea.right,
              y1: isNaN(v.value.absoluteZero) ? v.value.drawingArea.bottom : v.value.absoluteZero,
              y2: isNaN(v.value.absoluteZero) ? v.value.drawingArea.bottom : v.value.absoluteZero,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ca)
          ])) : p("", !0),
          e.value.xyShowScale ? (a(), l("g", Pa, [
            (a(!0), l(m, null, L(v.value.yLabels, (t, u) => (a(), l(m, null, [
              t.y <= v.value.drawingArea.bottom ? (a(), l("line", {
                key: 0,
                x1: t.x + 4,
                x2: v.value.drawingArea.left,
                y1: t.y,
                y2: t.y,
                stroke: e.value.xyAxisStroke,
                "stroke-width": e.value.xyAxisStrokeWidth,
                "stroke-linecap": "round"
              }, null, 8, Ia)) : p("", !0),
              t.y <= v.value.drawingArea.bottom ? (a(), l("text", {
                key: 1,
                x: t.x,
                y: t.y + e.value.xyLabelsYFontSize / 3,
                "text-anchor": "end",
                "font-size": e.value.xyLabelsYFontSize,
                fill: e.value.color
              }, T(f(H)(
                e.value.formatter,
                t.value,
                f(O)({
                  p: e.value.valuePrefix,
                  v: t.value,
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: t, seriesIndex: u }
              )), 9, Ea)) : p("", !0)
            ], 64))), 256))
          ])) : p("", !0),
          e.value.xyShowScale && e.value.xyPeriods.length ? (a(), l("g", Ta, [
            (a(!0), l(m, null, L(e.value.xyPeriods.slice(S.value.start, S.value.end), (t, u) => (a(), l("line", {
              x1: v.value.drawingArea.left + v.value.slotSize * (u + 1) - v.value.slotSize / 2,
              x2: v.value.drawingArea.left + v.value.slotSize * (u + 1) - v.value.slotSize / 2,
              y1: v.value.drawingArea.bottom,
              y2: v.value.drawingArea.bottom + 4,
              stroke: e.value.xyAxisStroke,
              "stroke-width": e.value.xyAxisStrokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ra))), 256)),
            (a(!0), l(m, null, L(e.value.xyPeriods.slice(S.value.start, S.value.end), (t, u) => (a(), l("text", {
              "font-size": e.value.xyLabelsXFontSize,
              "text-anchor": e.value.xyPeriodLabelsRotation > 0 ? "start" : e.value.xyPeriodLabelsRotation < 0 ? "end" : "middle",
              transform: `translate(${v.value.drawingArea.left + v.value.slotSize * (u + 1) - v.value.slotSize / 2}, ${v.value.drawingArea.bottom + e.value.xyLabelsXFontSize + 6}) rotate(${e.value.xyPeriodLabelsRotation})`,
              fill: e.value.color
            }, T(t), 9, Na))), 256))
          ])) : p("", !0),
          _("g", Fa, [
            (a(!0), l(m, null, L(v.value.dataset, (t, u) => (a(), l(m, null, [
              (a(!0), l(m, null, L(t.coordinates, (n, h) => (a(), l("rect", {
                x: n.x,
                width: n.width <= 0 ? 1e-5 : n.width,
                height: f(X)(n.height <= 0 ? 1e-5 : n.height),
                y: f(X)(n.y),
                fill: t.color,
                stroke: e.value.backgroundColor,
                "stroke-width": e.value.barStrokeWidth,
                "stroke-linecap": "round",
                class: ne({ "vue-data-ui-bar-animated": e.value.barAnimated && n.value < 0 })
              }, [
                e.value.barAnimated && n.value > 0 && !f(ye) && !f(ke) ? (a(), l("animate", {
                  key: 0,
                  attributeName: "height",
                  from: 0,
                  to: n.height,
                  dur: "0.5s"
                }, null, 8, Oa)) : p("", !0),
                e.value.barAnimated && n.value > 0 && !f(ye) && !f(ke) ? (a(), l("animate", {
                  key: 1,
                  attributeName: "y",
                  from: v.value.absoluteZero,
                  to: v.value.absoluteZero - n.height,
                  dur: "0.5s"
                }, null, 8, Ba)) : p("", !0)
              ], 10, Ma))), 256))
            ], 64))), 256))
          ]),
          e.value.showDataLabels ? (a(), l("g", Ua, [
            (a(!0), l(m, null, L(v.value.dataset, (t, u) => (a(), l(m, null, [
              (a(!0), l(m, null, L(t.coordinates, (n, h) => (a(), l("text", {
                x: n.x + n.width / 2,
                y: f(X)(n.y) - e.value.dataLabelFontSize / 2,
                "text-anchor": "middle",
                "font-size": e.value.dataLabelFontSize,
                fill: t.color,
                class: "quick-animation"
              }, T(f(H)(
                e.value.formatter,
                f(X)(n.value),
                f(O)({
                  p: e.value.valuePrefix,
                  v: f(X)(n.value),
                  s: e.value.valueSuffix,
                  r: e.value.dataLabelRoundingValue
                }),
                { datapoint: n, seriesIndex: h }
              )), 9, Da))), 256))
            ], 64))), 256))
          ])) : p("", !0),
          _("g", Va, [
            (a(!0), l(m, null, L(v.value.extremes.maxSeries, (t, u) => (a(), l("rect", {
              x: v.value.drawingArea.left + u * v.value.slotSize,
              y: v.value.drawingArea.top,
              height: v.value.drawingArea.height <= 0 ? 1e-5 : v.value.drawingArea.height,
              width: v.value.slotSize <= 0 ? 1e-5 : v.value.slotSize,
              fill: [q.value, Y.value].includes(u) ? e.value.xyHighlighterColor : "transparent",
              style: F(`opacity:${e.value.xyHighlighterOpacity}`),
              onMouseenter: (n) => v.value.useTooltip(u),
              onMouseleave: c[2] || (c[2] = (n) => v.value.killTooltip()),
              onClick: (n) => g("selectDatapoint", v.value.dataset.map((h) => ({
                ...h,
                value: h.values[u]
              })))
            }, null, 44, qa))), 256))
          ])
        ], 64)) : p("", !0),
        [A.LINE, A.BAR].includes(z.value) ? (a(), l("g", Wa, [
          e.value.xAxisLabel && z.value === A.LINE ? (a(), l("g", ja, [
            _("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              "text-anchor": "middle",
              x: d.value.drawingArea.left + d.value.drawingArea.width / 2,
              y: b.value.height - e.value.axisLabelsFontSize / 3
            }, T(e.value.xAxisLabel), 9, Ga)
          ])) : p("", !0),
          e.value.xAxisLabel && z.value === A.BAR ? (a(), l("g", Ha, [
            _("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              "text-anchor": "middle",
              x: v.value.drawingArea.left + v.value.drawingArea.width / 2,
              y: b.value.height - e.value.axisLabelsFontSize / 3
            }, T(e.value.xAxisLabel), 9, Xa)
          ])) : p("", !0),
          e.value.yAxisLabel && z.value === A.LINE ? (a(), l("g", Za, [
            _("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              transform: `translate(${e.value.axisLabelsFontSize}, ${d.value.drawingArea.top + d.value.drawingArea.height / 2}) rotate(-90)`,
              "text-anchor": "middle"
            }, T(e.value.yAxisLabel), 9, Ya)
          ])) : p("", !0),
          e.value.yAxisLabel && z.value === A.BAR ? (a(), l("g", Ja, [
            _("text", {
              "font-size": e.value.axisLabelsFontSize,
              fill: e.value.color,
              transform: `translate(${e.value.axisLabelsFontSize}, ${v.value.drawingArea.top + v.value.drawingArea.height / 2}) rotate(-90)`,
              "text-anchor": "middle"
            }, T(e.value.yAxisLabel), 9, Qa)
          ])) : p("", !0)
        ])) : p("", !0)
      ], 12, Nt)) : p("", !0),
      z.value ? p("", !0) : (a(), Pe(Lt, {
        key: 3,
        config: {
          type: "line",
          style: {
            backgroundColor: e.value.backgroundColor,
            line: {
              axis: {
                color: e.value.xyAxisStroke
              },
              path: {
                color: e.value.xyAxisStroke,
                strokeWidth: 0.5
              }
            }
          }
        }
      }, null, 8, ["config"])),
      r.$slots.watermark ? (a(), l("div", Ka, [
        D(r.$slots, "watermark", J(fe({ isPrinting: f(ye) || f(ke) })), void 0, !0)
      ])) : p("", !0),
      [A.BAR, A.LINE].includes(z.value) && e.value.zoomXy && k.value.maxSeriesLength > 1 ? (a(), l("div", {
        key: `slicer_${ze.value}`,
        ref_key: "quickChartSlicer",
        ref: re
      }, [
        (a(), Pe(At, {
          key: `slicer_${ze.value}`,
          background: e.value.zoomColor,
          borderColor: e.value.backgroundColor,
          fontSize: e.value.zoomFontSize,
          useResetSlot: e.value.zoomUseResetSlot,
          labelLeft: e.value.xyPeriods[S.value.start] ? e.value.xyPeriods[S.value.start] : "",
          labelRight: e.value.xyPeriods[S.value.end - 1] ? e.value.xyPeriods[S.value.end - 1] : "",
          textColor: e.value.color,
          inputColor: e.value.zoomColor,
          selectColor: e.value.zoomHighlightColor,
          max: k.value.maxSeriesLength,
          min: 0,
          valueStart: S.value.start,
          valueEnd: S.value.end,
          smoothMinimap: e.value.zoomMinimap.smooth,
          minimapSelectedColor: e.value.zoomMinimap.selectedColor,
          minimapSelectedColorOpacity: e.value.zoomMinimap.selectedColorOpacity,
          minimapSelectionRadius: e.value.zoomMinimap.selectionRadius,
          minimapLineColor: e.value.zoomMinimap.lineColor,
          minimap: at.value,
          minimapIndicatorColor: e.value.zoomMinimap.indicatorColor,
          minimapSelectedIndex: Y.value,
          start: S.value.start,
          "onUpdate:start": c[3] || (c[3] = (t) => S.value.start = t),
          end: S.value.end,
          "onUpdate:end": c[4] || (c[4] = (t) => S.value.end = t),
          onReset: tt,
          onTrapMouse: et
        }, {
          "reset-action": ae(({ reset: t }) => [
            D(r.$slots, "reset-action", J(fe({ reset: t })), void 0, !0)
          ]),
          _: 3
        }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "smoothMinimap", "minimapSelectedColor", "minimapSelectedColorOpacity", "minimapSelectionRadius", "minimapLineColor", "minimap", "minimapIndicatorColor", "minimapSelectedIndex", "start", "end"]))
      ])) : p("", !0),
      e.value.showLegend ? (a(), l("div", {
        key: 6,
        ref_key: "quickChartLegend",
        ref: oe,
        class: "vue-ui-quick-chart-legend",
        style: F(`background:${e.value.backgroundColor};color:${e.value.color}`)
      }, [
        z.value === A.DONUT ? (a(!0), l(m, { key: 0 }, L(C.value.legend, (t, u) => (a(), l("div", {
          class: "vue-ui-quick-chart-legend-item",
          onClick: (n) => {
            Ke(t, C.value.dataset), g("selectLegend", t);
          },
          style: F(`cursor: ${C.value.legend.length > 1 ? "pointer" : "default"}; opacity:${w.value.includes(t.id) ? "0.5" : "1"}`)
        }, [
          e.value.useCustomLegend ? D(r.$slots, "legend", J(Ie({ key: 0 }, { legend: t })), void 0, !0) : (a(), l(m, { key: 1 }, [
            ge(Ae, {
              name: e.value.legendIcon,
              stroke: t.color,
              size: e.value.legendIconSize
            }, null, 8, ["name", "stroke", "size"]),
            _("span", {
              style: F(`font-size:${e.value.legendFontSize}px`)
            }, T(t.name), 5),
            _("span", {
              style: F(`font-size:${e.value.legendFontSize}px;font-variant-numeric:tabular-nums`)
            }, T(w.value.includes(t.id) ? "-" : f(H)(
              e.value.formatter,
              t.absoluteValue,
              f(O)({
                p: e.value.valuePrefix,
                v: t.absoluteValue,
                s: e.value.valueSuffix,
                r: e.value.dataLabelRoundingValue
              }),
              { datapoint: t, seriesIndex: u }
            )), 5),
            w.value.includes(t.id) ? (a(), l("span", {
              key: 0,
              style: F(`font-size:${e.value.legendFontSize}px`)
            }, " ( - % ) ", 4)) : we.value ? (a(), l("span", {
              key: 1,
              style: F(`font-size:${e.value.legendFontSize}px; font-variant-numeric: tabular-nums;`)
            }, " ( - % ) ", 4)) : (a(), l("span", {
              key: 2,
              style: F(`font-size:${e.value.legendFontSize}px; font-variant-numeric: tabular-nums;`)
            }, " (" + T(f(O)({
              v: t.value / C.value.total * 100,
              s: "%",
              r: e.value.dataLabelRoundingPercentage
            })) + ") ", 5))
          ], 64))
        ], 12, el))), 256)) : p("", !0),
        z.value === A.LINE ? (a(!0), l(m, { key: 1 }, L(d.value.legend, (t, u) => (a(), l("div", {
          class: "vue-ui-quick-chart-legend-item",
          onClick: (n) => {
            Be(t.id, d.value.legend.length - 1), g("selectLegend", t);
          },
          style: F(`cursor: ${d.value.legend.length > 1 ? "pointer" : "default"}; opacity:${w.value.includes(t.id) ? "0.5" : "1"}`)
        }, [
          e.value.useCustomLegend ? D(r.$slots, "legend", J(Ie({ key: 0 }, { legend: t })), void 0, !0) : (a(), l(m, { key: 1 }, [
            ge(Ae, {
              name: e.value.legendIcon,
              stroke: t.color,
              size: e.value.legendIconSize
            }, null, 8, ["name", "stroke", "size"]),
            _("span", {
              style: F(`font-size:${e.value.legendFontSize}px`)
            }, T(t.name), 5)
          ], 64))
        ], 12, tl))), 256)) : p("", !0),
        z.value === A.BAR ? (a(!0), l(m, { key: 2 }, L(v.value.legend, (t, u) => (a(), l("div", {
          class: "vue-ui-quick-chart-legend-item",
          onClick: (n) => {
            Be(t.id, v.value.legend.length - 1), g("selectLegend", t);
          },
          style: F(`cursor: ${v.value.legend.length > 1 ? "pointer" : "default"}; opacity:${w.value.includes(t.id) ? "0.5" : "1"}`)
        }, [
          e.value.useCustomLegend ? D(r.$slots, "legend", J(Ie({ key: 0 }, { legend: t })), void 0, !0) : (a(), l(m, { key: 1 }, [
            ge(Ae, {
              name: e.value.legendIcon,
              stroke: t.color,
              size: e.value.legendIconSize
            }, null, 8, ["name", "stroke", "size"]),
            _("span", {
              style: F(`font-size:${e.value.legendFontSize}px`)
            }, T(t.name), 5)
          ], 64))
        ], 12, al))), 256)) : p("", !0)
      ], 4)) : p("", !0),
      ge(St, {
        show: be.value.showTooltip && G.value,
        backgroundColor: e.value.backgroundColor,
        color: e.value.color,
        borderRadius: e.value.tooltipBorderRadius,
        borderColor: e.value.tooltipBorderColor,
        borderWidth: e.value.tooltipBorderWidth,
        fontSize: e.value.tooltipFontSize,
        backgroundOpacity: e.value.tooltipBackgroundOpacity,
        position: e.value.tooltipPosition,
        offsetY: e.value.tooltipOffsetY,
        parent: j.value,
        content: Q.value,
        isCustom: f(_e)(e.value.tooltipCustomFormat)
      }, {
        "tooltip-before": ae(() => [
          D(r.$slots, "tooltip-before", J(fe({ ...se.value })), void 0, !0)
        ]),
        "tooltip-after": ae(() => [
          D(r.$slots, "tooltip-after", J(fe({ ...se.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"])
    ], 14, Rt)) : (a(), l("div", ll, [
      ge(Ae, {
        name: "circleCancel",
        stroke: "red"
      }),
      ol
    ]));
  }
}, ml = /* @__PURE__ */ zt(il, [["__scopeId", "data-v-bf59d888"]]);
export {
  ml as default
};
