import { computed as v, ref as k, watch as Z, onMounted as ee, openBlock as u, createElementBlock as c, normalizeClass as O, normalizeStyle as S, createVNode as te, createCommentVNode as b, createBlock as T, unref as h, createSlots as ae, withCtx as A, renderSlot as w, normalizeProps as X, guardReactiveProps as D, Fragment as H, renderList as R, toDisplayString as le } from "vue";
import { u as Y } from "./useNestedProp-lS_T5lM3.js";
import { u as oe, c as se, t as re, s as ue, o as ne, e as ie, v as q, X as ce, i as ve, f as he } from "./index-C8SH0f2u.js";
import { _ as de } from "./Title-DZjnxQdN.js";
import { u as me, U as ye } from "./usePrinter-Dj50NAxo.js";
import ge from "./vue-ui-skeleton-B4eWLjH3.js";
import { _ as fe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const pe = ["id"], ke = ["xmlns", "viewBox"], be = { key: 0 }, _e = ["d", "stroke-width", "stroke"], Ce = { key: 1 }, $e = ["x1", "y1", "x2", "y2", "stroke-width", "stroke"], xe = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], we = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Pe = {
  __name: "vue-ui-tiremarks",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(J, { expose: K }) {
    const d = J, { vue_ui_tiremarks: Q } = oe(), F = v(() => !!d.dataset && Object.keys(d.dataset).length), z = k(se()), N = k(null), G = k(0), e = v(() => {
      const t = Y({
        userConfig: d.config,
        defaultConfig: Q
      });
      return t.theme ? {
        ...Y({
          userConfig: re.vue_ui_tiremarks[t.theme] || d.config,
          defaultConfig: t
        })
      } : t;
    }), { isPrinting: L, isImaging: M, generatePdf: U, generateImage: j } = me({
      elementId: z.value,
      fileName: e.value.style.chart.title.text || "vue-ui-tiremarks"
    }), s = k(e.value.style.chart.animation.use ? 0 : ue(d.dataset.percentage));
    Z(() => d.dataset, (t) => {
      e.value.style.chart.animation.use ? B(t.percentage) : s.value = t.percentage || 0;
    }, { deep: !0 }), ee(() => {
      ne(d.dataset) && ie({
        componentName: "VueUiTiremarks",
        type: "dataset"
      }), B(d.dataset.percentage || 0);
    });
    function B(t) {
      let n = e.value.style.chart.animation.speed;
      const a = Math.abs(t - s.value) / (n * 120);
      function o() {
        s.value < t ? s.value = Math.min(s.value + a, t) : s.value > t && (s.value = Math.max(s.value - a, t)), s.value !== t && requestAnimationFrame(o);
      }
      o();
    }
    const p = v(() => e.value.style.chart.layout.display === "vertical"), r = v(() => {
      const t = {
        top: 48,
        left: 64,
        right: 64,
        bottom: 48
      };
      return p.value ? {
        top: e.value.style.chart.percentage.verticalPosition === "top" ? t.top : 3,
        left: 3,
        right: 3,
        bottom: e.value.style.chart.percentage.verticalPosition === "bottom" ? t.bottom : 3
      } : {
        top: 0,
        bottom: 0,
        left: e.value.style.chart.percentage.horizontalPosition === "left" ? t.left : 3,
        right: e.value.style.chart.percentage.horizontalPosition === "right" ? t.right : 10
      };
    }), P = v(() => Object.values(r.value).reduce((t, n) => t + n, 0)), l = v(() => ({
      height: p.value ? 312 : 56,
      width: p.value ? 56 : 312
    })), V = k(100);
    v(() => d.dataset.percentage / V.value);
    const i = v(() => p.value ? {
      mark: (l.value.height - P.value) / 100 * 0.5,
      space: (l.value.height - P.value) / 100 * 0.5
    } : {
      mark: (l.value.width - P.value) / 100 * 0.5,
      space: (l.value.width - P.value) / 100 * 0.5
    }), E = v(() => {
      const t = [];
      for (let a = 0; a < 100; a += 1) {
        const o = e.value.style.chart.layout.ticks.gradient.show ? q(e.value.style.chart.layout.activeColor, a / 100 * (e.value.style.chart.layout.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.activeColor;
        if (p.value) {
          const C = e.value.style.chart.layout.crescendo ? (100 - a) * (l.value.width - r.value.left - r.value.right) / 100 / 3 : 0, m = r.value.left + 4 + C, y = l.value.width - r.value.right - 4 - C, g = l.value.height - r.value.bottom - a * i.value.mark - a * i.value.space - i.value.mark, f = l.value.height - r.value.bottom - a * i.value.mark - a * i.value.space - i.value.mark, $ = (y - m) / e.value.style.chart.layout.curveAngleX, x = e.value.style.chart.layout.curveAngleY * ((1 + a) / 100);
          t.push({
            x1: m,
            x2: y,
            y1: g,
            y2: f,
            curve: `M ${m} ${g} C ${m + $} ${g - x}, ${y - $} ${f - x}, ${y} ${f}`,
            color: o
          });
        } else {
          const C = e.value.style.chart.layout.crescendo ? (100 - a) * (l.value.height - r.value.top - r.value.bottom) / 100 / 3 : 0, m = r.value.left + a * i.value.mark + a * i.value.space - i.value.mark, y = m, g = r.value.top + 4 + C, f = l.value.height - r.value.bottom - 4 - C, $ = e.value.style.chart.layout.curveAngleY * ((1 + a) / 100), x = (f - g) / e.value.style.chart.layout.curveAngleX;
          t.push({
            x1: m,
            x2: y,
            y1: g,
            y2: f,
            curve: `M ${m} ${g} C ${m + $} ${g + x}, ${y + $} ${f - x}, ${y} ${f}`,
            color: o
          });
        }
      }
      return t;
    }), _ = v(() => {
      let t, n, a;
      const o = e.value.style.chart.percentage.fontSize / 3;
      return p.value ? e.value.style.chart.percentage.verticalPosition === "top" ? (t = l.value.width / 2, n = r.value.top / 2, a = "middle") : e.value.style.chart.percentage.verticalPosition === "bottom" && (t = l.value.width / 2, n = l.value.height - r.value.bottom / 2 + o, a = "middle") : e.value.style.chart.percentage.horizontalPosition === "left" ? (t = 4, n = l.value.height / 2 + o, a = "start") : e.value.style.chart.percentage.horizontalPosition === "right" && (t = l.value.width - r.value.right + 8, n = l.value.height / 2 + o, a = "start"), {
        x: t,
        y: n,
        textAnchor: a,
        bold: e.value.style.chart.percentage.bold,
        fontSize: e.value.style.chart.percentage.fontSize,
        fill: e.value.style.chart.percentage.color
      };
    }), I = k(!1);
    function W(t) {
      I.value = t, G.value += 1;
    }
    return K({
      generatePdf: U,
      generateImage: j
    }), (t, n) => (u(), c("div", {
      ref_key: "tiremarksChart",
      ref: N,
      class: O(`vue-ui-tiremarks ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: S(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor}`),
      id: z.value
    }, [
      e.value.style.chart.title.text ? (u(), c("div", {
        key: 0,
        style: S(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:12px`)
      }, [
        te(de, {
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : b("", !0),
      e.value.userOptions.show && F.value ? (u(), T(ye, {
        ref: "details",
        key: `user_options_${G.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: h(L),
        isImaging: h(M),
        uid: z.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: I.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: N.value,
        onToggleFullscreen: W,
        onGeneratePdf: h(U),
        onGenerateImage: h(j)
      }, ae({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: A(() => [
            w(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: A(() => [
            w(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: A(({ toggleFullscreen: a, isFullscreen: o }) => [
            w(t.$slots, "optionFullscreen", X(D({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : b("", !0),
      F.value ? (u(), c("svg", {
        key: 2,
        xmlns: h(ce),
        class: O({ "vue-data-ui-fullscreen--on": I.value, "vue-data-ui-fulscreen--off": !I.value }),
        viewBox: `0 0 ${l.value.width} ${l.value.height}`,
        style: S(`max-width:100%; overflow: visible; background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        e.value.style.chart.layout.curved ? (u(), c("g", be, [
          (u(!0), c(H, null, R(E.value, (a, o) => (u(), c("path", {
            d: a.curve,
            "stroke-width": i.value.mark,
            stroke: s.value >= o ? a.color : e.value.style.chart.layout.inactiveColor,
            "stroke-linecap": "round",
            fill: "none",
            class: O({ "vue-ui-tick-animated": e.value.style.chart.animation.use && o <= s.value })
          }, null, 10, _e))), 256))
        ])) : (u(), c("g", Ce, [
          (u(!0), c(H, null, R(E.value, (a, o) => (u(), c("line", {
            x1: a.x1,
            y1: a.y1,
            x2: a.x2,
            y2: a.y2,
            "stroke-width": i.value.mark,
            stroke: s.value >= o ? a.color : e.value.style.chart.layout.inactiveColor,
            "stroke-linecap": "round"
          }, null, 8, $e))), 256))
        ])),
        e.value.style.chart.percentage.show ? (u(), c("text", {
          key: 2,
          x: _.value.x,
          y: _.value.y,
          "font-size": _.value.fontSize,
          fill: e.value.style.chart.layout.ticks.gradient.show && e.value.style.chart.percentage.useGradientColor ? h(q)(e.value.style.chart.layout.activeColor, s.value / 100 * (e.value.style.chart.layout.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.percentage.color,
          "font-weight": _.value.bold ? "bold" : "normal",
          "text-anchor": _.value.textAnchor
        }, le(h(ve)(
          e.value.style.chart.percentage.formatter,
          s.value,
          h(he)({
            v: s.value,
            s: "%",
            r: e.value.style.chart.percentage.rounding
          })
        )), 9, xe)) : b("", !0),
        w(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, ke)) : b("", !0),
      t.$slots.watermark ? (u(), c("div", we, [
        w(t.$slots, "watermark", X(D({ isPrinting: h(L) || h(M) })), void 0, !0)
      ])) : b("", !0),
      F.value ? b("", !0) : (u(), T(ge, {
        key: 4,
        config: {
          type: "tiremarks",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            tiremarks: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 14, pe));
  }
}, Ge = /* @__PURE__ */ fe(Pe, [["__scopeId", "data-v-4f20846e"]]);
export {
  Ge as default
};
