import { computed as p, ref as r, watch as J, onMounted as K, onBeforeUnmount as Q, openBlock as u, createElementBlock as v, normalizeStyle as C, createVNode as Z, createCommentVNode as d, createBlock as M, unref as n, createSlots as V, withCtx as _, renderSlot as y, normalizeProps as N, guardReactiveProps as A, normalizeClass as L, Fragment as ee, renderList as te, toDisplayString as ae } from "vue";
import { u as le, c as se, t as ne, o as oe, e as re, v as U, X as ue, i as ie, s as X, f as ce } from "./index-C8SH0f2u.js";
import { _ as he } from "./Title-DZjnxQdN.js";
import { u as ve, U as de } from "./usePrinter-Dj50NAxo.js";
import { t as ye, u as fe } from "./useResponsive-NZB-WLRF.js";
import me from "./vue-ui-skeleton-B4eWLjH3.js";
import { u as B } from "./useNestedProp-lS_T5lM3.js";
import { _ as ge } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const pe = ["id"], ke = ["xmlns", "viewBox"], we = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-linecap"], be = ["cx", "cy", "r", "stroke", "stroke-width"], Ce = ["x", "y", "font-size", "fill", "font-weight"], _e = {
  key: 3,
  class: "vue-data-ui-watermark"
}, xe = {
  __name: "vue-ui-wheel",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(G, { expose: T }) {
    const h = G, { vue_ui_wheel: E } = le(), k = p(() => !!h.dataset && Object.keys(h.dataset).length), w = r(se()), j = r(null), x = r(0), f = r(null), I = r(null), e = p(() => {
      const t = B({
        userConfig: h.config,
        defaultConfig: E
      });
      return t.theme ? {
        ...B({
          userConfig: ne.vue_ui_wheel[t.theme] || h.config,
          defaultConfig: t
        })
      } : t;
    }), { isPrinting: $, isImaging: F, generatePdf: P, generateImage: z } = ve({
      elementId: w.value,
      fileName: e.value.style.chart.title.text || "vue-ui-wheel"
    }), l = r({
      size: 360,
      height: 360,
      width: 360
    }), b = r(e.value.style.chart.layout.percentage.fontSize), o = p(() => ({
      radius: Math.min(l.value.width, l.value.height) * 0.9 / 2,
      centerX: l.value.width / 2,
      centerY: l.value.height / 2
    }));
    function O(t, i = 1) {
      return {
        x: o.value.centerX + o.value.radius * Math.cos(29.85 + t * Math.PI / 180) * i,
        y: o.value.centerY + o.value.radius * Math.sin(29.85 + t * Math.PI / 180) * i
      };
    }
    const s = r(e.value.style.chart.animation.use ? 0 : h.dataset.percentage || 0);
    J(() => h.dataset, (t) => {
      e.value.style.chart.animation.use ? S(t.percentage) : s.value = t.percentage || 0;
    }, { deep: !0 });
    const m = r(null);
    K(() => {
      if (oe(h.dataset) && re({
        componentName: "VueUiWheel",
        type: "dataset"
      }), S(h.dataset.percentage || 0), e.value.responsive) {
        const t = ye(() => {
          const { width: i, height: a } = fe({
            chart: f.value,
            title: e.value.style.chart.title.text ? I.value : null
          });
          l.value.width = i, l.value.height = a, b.value = e.value.style.chart.layout.percentage.fontSize / 360 * Math.min(i, a);
        });
        m.value = new ResizeObserver(t), m.value.observe(f.value.parentNode);
      }
    }), Q(() => {
      m.value && m.value.disconnect();
    });
    function S(t) {
      let i = e.value.style.chart.animation.speed;
      const a = Math.abs(t - s.value) / (i * 120);
      function c() {
        s.value < t ? s.value = Math.min(s.value + a, t) : s.value > t && (s.value = Math.max(s.value - a, t)), s.value !== t && requestAnimationFrame(c);
      }
      c();
    }
    const D = p(() => {
      const t = [];
      for (let a = 0; a < 100; a += 1) {
        const c = s.value > a ? e.value.style.chart.layout.wheel.ticks.activeColor : e.value.style.chart.layout.wheel.ticks.inactiveColor, { x: Y, y: H } = O(l.value.size / 100 * a), { x: W, y: q } = O(l.value.size / 100 * a, 0.9);
        t.push({
          x1: Y,
          y1: H,
          x2: W,
          y2: q,
          color: e.value.style.chart.layout.wheel.ticks.gradient.show ? U(c, a / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : c
        });
      }
      return t;
    }), g = r(!1);
    function R(t) {
      g.value = t, x.value += 1;
    }
    return T({
      generatePdf: P,
      generateImage: z
    }), (t, i) => (u(), v("div", {
      class: "vue-ui-wheel",
      ref_key: "wheelChart",
      ref: f,
      id: w.value,
      style: C(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height:100%" : ""}`)
    }, [
      e.value.style.chart.title.text ? (u(), v("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: I,
        style: C(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:12px`)
      }, [
        Z(he, {
          config: {
            title: {
              cy: "wheel-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "wheel-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : d("", !0),
      e.value.userOptions.show && k.value ? (u(), M(de, {
        ref_key: "details",
        ref: j,
        key: `user_options_${x.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: n($),
        isImaging: n(F),
        uid: w.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        hasXls: !1,
        isFullscreen: g.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: f.value,
        onToggleFullscreen: R,
        onGeneratePdf: n(P),
        onGenerateImage: n(z)
      }, V({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            y(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            y(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: a, isFullscreen: c }) => [
            y(t.$slots, "optionFullscreen", N(A({ toggleFullscreen: a, isFullscreen: c })), void 0, !0)
          ]),
          key: "2"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasFullscreen", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : d("", !0),
      k.value ? (u(), v("svg", {
        key: 2,
        xmlns: n(ue),
        class: L({ "vue-data-ui-fullscreen--on": g.value, "vue-data-ui-fulscreen--off": !g.value }),
        viewBox: `0 0 ${l.value.width <= 0 ? 10 : l.value.width} ${l.value.height <= 0 ? 10 : l.value.height}`,
        style: C(`max-width:100%;overflow:visible;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        (u(!0), v(ee, null, te(D.value, (a, c) => (u(), v("line", {
          x1: a.x1,
          x2: a.x2,
          y1: a.y1,
          y2: a.y2,
          stroke: a.color,
          "stroke-width": 5 / 360 * Math.min(l.value.width, l.value.height),
          "stroke-linecap": e.value.style.chart.layout.wheel.ticks.rounded ? "round" : "butt",
          class: L({ "vue-ui-tick-animated": e.value.style.chart.animation.use && c <= s.value })
        }, null, 10, we))), 256)),
        e.value.style.chart.layout.innerCircle.show ? (u(), v("circle", {
          key: 0,
          cx: o.value.centerX,
          cy: o.value.centerY,
          r: o.value.radius * 0.8 <= 0 ? 1e-4 : o.value.radius * 0.8,
          stroke: e.value.style.chart.layout.innerCircle.stroke,
          "stroke-width": e.value.style.chart.layout.innerCircle.strokeWidth,
          fill: "none"
        }, null, 8, be)) : d("", !0),
        e.value.style.chart.layout.percentage.show ? (u(), v("text", {
          key: 1,
          x: o.value.centerX,
          y: o.value.centerY + b.value / 3,
          "font-size": b.value,
          fill: e.value.style.chart.layout.wheel.ticks.gradient.show ? n(U)(e.value.style.chart.layout.wheel.ticks.activeColor, s.value / 100 * (e.value.style.chart.layout.wheel.ticks.gradient.shiftHueIntensity / 100)) : e.value.style.chart.layout.wheel.ticks.activeColor,
          "text-anchor": "middle",
          "font-weight": e.value.style.chart.layout.percentage.bold ? "bold" : "normal",
          style: { "font-variant-numeric": "tabluar-nums" }
        }, ae(n(ie)(
          e.value.style.chart.layout.percentage.formatter,
          n(X)(s.value),
          n(ce)({
            v: n(X)(s.value),
            s: "%",
            r: e.value.style.chart.layout.percentage.rounding
          })
        )), 9, Ce)) : d("", !0),
        y(t.$slots, "svg", { svg: l.value }, void 0, !0)
      ], 14, ke)) : d("", !0),
      t.$slots.watermark ? (u(), v("div", _e, [
        y(t.$slots, "watermark", N(A({ isPrinting: n($) || n(F) })), void 0, !0)
      ])) : d("", !0),
      k.value ? d("", !0) : (u(), M(me, {
        key: 4,
        config: {
          type: "wheel",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            wheel: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"]))
    ], 12, pe));
  }
}, Ne = /* @__PURE__ */ ge(xe, [["__scopeId", "data-v-929bab56"]]);
export {
  Ne as default
};
