import { useCssVars as Ge, computed as b, ref as v, onMounted as Ue, onBeforeUnmount as He, openBlock as s, createElementBlock as d, normalizeClass as D, normalizeStyle as r, createVNode as G, createCommentVNode as m, createBlock as ne, unref as h, createSlots as We, withCtx as x, renderSlot as k, normalizeProps as q, guardReactiveProps as K, createElementVNode as n, toDisplayString as i, Fragment as U, renderList as H, withKeys as je, createTextVNode as Ye } from "vue";
import { u as qe, c as Ke, t as Je, a as Qe, p as M, b as Ze, o as Te, e as J, s as S, d as ue, i as Q, f as I, X as et, v as tt, w as se, x as at, y as lt, q as ot, r as nt } from "./index-C8SH0f2u.js";
import { t as ut, u as st } from "./useResponsive-NZB-WLRF.js";
import { _ as rt } from "./Title-DZjnxQdN.js";
import { u as it, U as dt } from "./usePrinter-Dj50NAxo.js";
import { _ as ct } from "./Tooltip--kgFEVZs.js";
import { L as Le } from "./Legend-Cj7T-DqJ.js";
import vt from "./vue-ui-skeleton-B4eWLjH3.js";
import ht from "./BaseIcon-kBIAYqUO.js";
import pt from "./vue-ui-accordion-YHleIgkV.js";
import { u as Ne } from "./useNestedProp-lS_T5lM3.js";
import { _ as yt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const gt = ["id"], ft = ["onClick"], bt = ["xmlns", "viewBox"], mt = ["id"], _t = ["stop-color"], xt = ["stop-color"], kt = ["x", "y", "width", "height", "fill", "rx"], $t = ["x", "y", "width", "height", "fill", "rx", "stroke", "stroke-width"], wt = ["x2", "y1", "y2", "stroke", "stroke-width"], Ct = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Tt = ["x", "y", "text-anchor", "font-size", "fill", "font-weight"], Lt = ["x", "y", "font-size", "fill", "font-weight"], Nt = ["x", "y", "font-size", "fill", "font-weight"], Pt = ["x", "y", "font-size", "fill", "font-weight"], St = ["y", "width", "height", "fill", "onMouseenter"], Vt = {
  key: 4,
  class: "vue-data-ui-watermark"
}, zt = ["onClick"], Ft = { style: "width:100%;padding-top: 36px;position:relative" }, Mt = { class: "vue-ui-data-table" }, It = { key: 0 }, Bt = { style: { width: "100%" } }, Ot = ["data-cell"], Dt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Rt = ["data-cell"], Xt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, At = ["data-cell"], Et = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Gt = ["data-cell"], Ut = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Ht = ["data-cell"], Wt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, jt = ["data-cell"], Yt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, qt = ["data-cell"], Kt = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Jt = {
  __name: "vue-ui-vertical-bar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(Pe, { expose: Se, emit: Ve }) {
    const N = Pe;
    Ge((a) => ({
      ad951260: a.tdo
    }));
    const { vue_ui_vertical_bar: ze } = qe(), W = b(() => !!N.dataset && N.dataset.length), V = v(Ke()), Fe = v(null), Z = v(!1), ee = v(""), j = v(0), Me = v(null), re = v(0), R = v(null), ie = v(null), te = v(null), e = b(() => {
      const a = Ne({
        userConfig: N.config,
        defaultConfig: ze
      });
      return a.theme ? {
        ...Ne({
          userConfig: Je.vue_ui_vertical_bar[a.theme] || N.config,
          defaultConfig: a
        }),
        customPalette: Qe[a.theme] || M
      } : a;
    }), { isPrinting: de, isImaging: ce, generatePdf: ve, generateImage: he } = it({
      elementId: `vue-ui-vertical-bar_${V.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-vertical-bar"
    }), pe = b(() => Ze(e.value.customPalette)), ye = v(null), ge = v(!1), Ie = b(() => e.value.table.responsiveBreakpoint), Y = v(null);
    Ue(() => {
      if (Te(N.dataset) && J({
        componentName: "VueUiVerticalBar",
        type: "dataset"
      }), j.value = N.dataset.flatMap((a) => a.children && a.children.length > 0 ? a.children.length : 1).reduce((a, l) => a + l, 0), Be(), e.value.responsive) {
        const a = ut(() => {
          const { width: l, height: t } = st({
            chart: R.value,
            title: e.value.style.chart.title.text ? ie.value : null,
            legend: e.value.style.chart.legend.show ? te.value : null
          });
          me.value = l, c.value = t / j.value - g.value * 2;
        });
        Y.value = new ResizeObserver(a), Y.value.observe(R.value.parentNode);
      }
    }), He(() => {
      Y.value && Y.value.disconnect();
    });
    function Be() {
      new ResizeObserver((l) => {
        l.forEach((t) => {
          ge.value = t.contentRect.width < Ie.value;
        });
      }).observe(ye.value);
    }
    const $ = v({
      showTable: e.value.table.show,
      sortDesc: e.value.style.chart.layout.bars.sort === "desc",
      showTooltip: e.value.style.chart.tooltip.show
    }), fe = b(() => $.value.sortDesc), z = b(() => (N.dataset.forEach((a, l) => {
      !a.value && !a.children && J({
        componentName: "VueUiVerticalBar",
        type: "datasetAttributeEmpty",
        property: `value (index ${l})`
      }), a.children && (Te(a.children) ? J({
        componentName: "VueUiVerticalBar",
        type: "datasetAttributeEmpty",
        property: `children (index ${l})`
      }) : a.children.forEach((t, o) => {
        [null, void 0].includes(t.name) && J({
          componentName: "VueUiVerticalBar",
          type: "datasetSerieAttribute",
          property: "name",
          key: "children",
          index: o
        });
      }));
    }), N.dataset.map((a, l) => {
      const t = `vertical_parent_${l}_${V.value}`, o = a.children && a.children.length > 0, f = S(a.value ? a.value : o ? a.children.map((_) => _.value || 0).reduce((_, L) => _ + L, 0) : 0), p = f >= 0 ? 1 : -1;
      return {
        ...a,
        id: t,
        shape: "square",
        opacity: C.value.includes(t) ? 0.5 : 1,
        value: Math.abs(f),
        sign: p,
        hasChildren: o,
        isChild: !1,
        segregate: () => X(t),
        isSegregated: C.value.includes(t),
        color: ue(a.color) || pe.value[l] || M[l] || M[l % M.length],
        children: !a.children || !a.children.length ? [] : a.children.toSorted((_, L) => fe.value ? L.value - _.value : _.value - L.value).map((_, L) => ({
          ..._,
          value: S(Math.abs(_.value)),
          sign: _.value >= 0 ? 1 : -1,
          isChild: !0,
          parentId: t,
          parentName: a.name,
          parentValue: f,
          parentSign: p,
          id: `vertical_child_${l}_${L}_${V.value}`,
          childIndex: L,
          color: ue(_.color) || ue(a.color) || pe.value[l] || M[l] || M[l % M.length]
        })).map((_, L) => ({
          ..._,
          isFirstChild: L === 0,
          isLastChild: L === a.children.length - 1
        }))
      };
    }).toSorted((a, l) => fe.value ? l.value - a.value : a.value - l.value))), be = b(() => ({
      cy: "vertical-bar-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    })), c = v(e.value.style.chart.layout.bars.height), g = v(e.value.style.chart.layout.bars.gap), Oe = b(() => (c.value + g.value) * j.value), me = v(512), y = b(() => ({
      width: me.value,
      height: Oe.value,
      padding: {
        top: 12,
        left: 128 + e.value.style.chart.layout.bars.offsetX,
        right: 64 + e.value.style.chart.layout.bars.paddingRight,
        bottom: 12
      }
    })), u = b(() => ({
      fullHeight: y.value.padding.top + y.value.padding.bottom + y.value.height,
      top: y.value.padding.top,
      left: y.value.padding.left,
      right: y.value.width - y.value.padding.right,
      bottom: y.value.padding.top + y.value.height,
      width: y.value.width - (y.value.padding.left + y.value.padding.right)
    }));
    function ae() {
      j.value = F.value.flatMap((a) => a.children && a.children.length > 0 ? a.children.length : 1).reduce((a, l) => a + l, 0);
    }
    const C = v([]);
    function X(a) {
      C.value.includes(a) ? C.value = C.value.filter((l) => l !== a) : C.value.push(a), ae(), Ve("selectLegend", F.value);
    }
    const F = b(() => z.value.filter((a) => !C.value.includes(a.id))), T = b(() => F.value.map((a) => Math.abs(a.value)).reduce((a, l) => a + l, 0));
    function _e(a, l = !1, t = 0) {
      return l ? I({
        v: S(Math.abs(a) / T.value * 100),
        s: "%",
        r: t
      }) : Math.abs(a) / T.value;
    }
    const B = b(() => F.value.flatMap((a) => a.hasChildren ? a.children : a)), O = b(() => B.value.map((a) => a.sign).includes(-1)), De = b(() => Math.max(...F.value.flatMap((a) => a.children && a.children.length ? Math.max(...a.children.map((l) => l.value)) : a.value)));
    function P(a) {
      const l = a / De.value;
      return u.value.width / (O.value ? 2 : 1) * l;
    }
    function Re(a) {
      return P(a) + u.value.left;
    }
    function A(a, l) {
      const t = F.value.find((p) => p.id === a.parentId), o = u.value.top + (g.value + c.value) * l, f = t.children.length * (g.value + c.value);
      return {
        y: o + f / 2 - e.value.style.chart.layout.bars.parentLabels.fontSize,
        name: t.name,
        value: [void 0, NaN, null].includes(t.value) ? "" : t.sign === 1 ? t.value : -t.value,
        percentageToTotal: isNaN(t.value / T.value) ? "" : _e(t.value, !0, e.value.style.chart.layout.bars.dataLabels.percentage.roundingPercentage),
        sign: t.sign
      };
    }
    function Xe() {
      return F.value;
    }
    const le = v(null), oe = v(null);
    function Ae(a, l) {
      oe.value = {
        datapoint: a,
        seriesIndex: l,
        series: z.value,
        config: e.value
      }, Z.value = !0, le.value = a.id;
      let t = "";
      const o = a.isChild ? a.parentName : a.name, f = a.isChild ? a.name : "", p = e.value.style.chart.tooltip.customFormat;
      at(p) && lt(() => p({
        datapoint: a,
        series: z.value,
        config: e.value,
        seriesIndex: l
      })) ? ee.value = p({
        datapoint: a,
        series: z.value,
        config: e.value,
        seriesIndex: l
      }) : (t += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;text-align:left;">
                <div style="display:flex;align-items:center;gap:4px;"><svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" height="12" width="12" rx="2" stroke="none" fill="${a.color}"/></svg> ${o}</div>
                ${f ? `<div>${f}</div>` : ""}
            </div>`, e.value.style.chart.tooltip.showValue && (t += `<div>${e.value.translations.value}: <b>${Q(
        e.value.style.chart.layout.bars.dataLabels.value.formatter,
        a.sign === 1 ? a.value : -a.value,
        I({
          p: e.value.style.chart.tooltip.prefix,
          v: a.sign === 1 ? a.value : -a.value,
          s: e.value.style.chart.tooltip.suffix,
          r: e.value.style.chart.tooltip.roundingValue
        }),
        { datapoint: a, seriesIndex: l }
      )}</b></div>`), e.value.style.chart.tooltip.showPercentage && (t += `<div>${e.value.translations.percentageToTotal} : <b>${I({
        v: Math.abs(a.value) / T.value * 100,
        s: "%",
        r: e.value.style.chart.tooltip.roundingPercentage
      })}</b></div>`, a.isChild && (t += `<div>${e.value.translations.percentageToSerie}: <b>${I({
        v: Math.abs(a.value) / Math.abs(a.parentValue) * 100,
        s: "%",
        r: e.value.style.chart.tooltip.roundingPercentage
      })}</b></div>`)), ee.value = `<div style="text-align:left">${t}</div>`);
    }
    function xe(a, l, t, o) {
      if (!e.value.style.chart.layout.bars.dataLabels.value.show)
        return "";
      const f = Q(
        e.value.style.chart.layout.bars.dataLabels.value.formatter,
        S(o === -1 && a >= 0 ? -a : a),
        I({
          p: e.value.style.chart.layout.bars.dataLabels.value.prefix,
          v: S(o === -1 && a >= 0 ? -a : a),
          s: e.value.style.chart.layout.bars.dataLabels.value.suffix,
          r: e.value.style.chart.layout.bars.dataLabels.value.roundingValue
        }),
        { datapoint: l, seriesIndex: t }
      ), p = `(${_e(a, !0, e.value.style.chart.layout.bars.dataLabels.percentage.roundingPercentage)})`;
      return `${f}${e.value.style.chart.layout.bars.dataLabels.percentage.show ? ` ${p}` : ""}`;
    }
    const w = b(() => {
      const a = [
        e.value.translations.parentName,
        e.value.translations.value,
        e.value.translations.percentageToTotal,
        e.value.translations.childName,
        e.value.translations.value,
        e.value.translations.percentageToSerie,
        e.value.translations.percentageToTotal
      ], l = B.value.map((t) => t.isChild ? t.isFirstChild ? {
        color: t.color,
        parentName: t.parentName,
        parentValue: t.parentValue,
        percentageToTotal: t.parentValue / T.value,
        childName: t.name,
        childValue: t.sign === 1 ? t.value : -t.value,
        childPercentageToParent: Math.abs(t.value) / Math.abs(t.parentValue),
        childPercentageToTotal: Math.abs(t.value) / T.value
      } : {
        color: "",
        parentName: "",
        parentValue: "",
        percentageToTotal: "",
        childName: t.name,
        childValue: t.sign === 1 ? t.value : -t.value,
        childPercentageToParent: Math.abs(t.value) / Math.abs(t.parentValue),
        childPercentageToTotal: Math.abs(t.value) / T.value
      } : {
        color: t.color,
        parentName: t.name,
        parentValue: t.sign === 1 ? t.value : -t.value,
        percentageToTotal: Math.abs(t.value) / T.value,
        childName: "",
        childValue: "",
        childPercentageToParent: "",
        childPercentageToTotal: ""
      });
      return { head: a, body: l };
    });
    function ke() {
      const a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], l = w.value.head, t = w.value.body.map((p) => [
        p.parentName,
        p.parentValue,
        p.percentageToTotal,
        p.childName,
        p.childValue,
        p.childPercentageToParent,
        p.childPercentageToTotal
      ]), o = a.concat([l]).concat(t), f = ot(o);
      nt({ csvContent: f, title: e.value.style.chart.title.text || "vue-ui-vertical-bar" });
    }
    const E = v(!1);
    function Ee(a) {
      E.value = a, re.value += 1;
    }
    function $e() {
      $.value.showTable = !$.value.showTable;
    }
    function we() {
      $.value.sortDesc = !$.value.sortDesc, ae();
    }
    function Ce() {
      $.value.showTooltip = !$.value.showTooltip;
    }
    return Se({
      getData: Xe,
      recalculateHeight: ae,
      generatePdf: ve,
      generateCsv: ke,
      generateImage: he,
      toggleTable: $e,
      toggleSort: we,
      toggleTooltip: Ce
    }), (a, l) => (s(), d("div", {
      class: D(`vue-ui-vertical-bar ${E.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "verticalBarChart",
      ref: R,
      id: `vue-ui-vertical-bar_${V.value}`,
      style: r(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.chart.title.text ? "" : "padding-top:36px"};background:${e.value.style.chart.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.style.chart.title.text ? (s(), d("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: ie,
        style: r(`width:100%;background:${e.value.style.chart.backgroundColor};padding-bottom:12px`)
      }, [
        G(rt, {
          config: {
            title: {
              cy: "vertical-bar-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "vertical-bar-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : m("", !0),
      e.value.userOptions.show && W.value ? (s(), ne(dt, {
        ref_key: "details",
        ref: Fe,
        key: `user_options_${re.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isImaging: h(ce),
        isPrinting: h(de),
        uid: V.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.chart.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasSort: e.value.userOptions.buttons.sort,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: E.value,
        isTooltip: $.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: R.value,
        onToggleFullscreen: Ee,
        onGeneratePdf: h(ve),
        onGenerateCsv: ke,
        onGenerateImage: h(he),
        onToggleTable: $e,
        onToggleSort: we,
        onToggleTooltip: Ce
      }, We({ _: 2 }, [
        a.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: x(() => [
            k(a.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        a.$slots.optionPdf ? {
          name: "optionPdf",
          fn: x(() => [
            k(a.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        a.$slots.optionCsv ? {
          name: "optionCsv",
          fn: x(() => [
            k(a.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        a.$slots.optionImg ? {
          name: "optionImg",
          fn: x(() => [
            k(a.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        a.$slots.optionTable ? {
          name: "optionTable",
          fn: x(() => [
            k(a.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        a.$slots.optionLabels ? {
          name: "optionLabels",
          fn: x(() => [
            k(a.$slots, "optionLabels", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        a.$slots.optionSort ? {
          name: "optionSort",
          fn: x(() => [
            k(a.$slots, "optionSort", {}, void 0, !0)
          ]),
          key: "6"
        } : void 0,
        a.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: x(({ toggleFullscreen: t, isFullscreen: o }) => [
            k(a.$slots, "optionFullscreen", q(K({ toggleFullscreen: t, isFullscreen: o })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasSort", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : m("", !0),
      e.value.style.chart.legend.show && e.value.style.chart.legend.position === "top" ? (s(), d("div", {
        key: 2,
        ref_key: "chartLegend",
        ref: te
      }, [
        G(Le, {
          legendSet: z.value,
          config: be.value,
          onClickMarker: l[0] || (l[0] = ({ legend: t }) => X(t.id))
        }, {
          item: x(({ legend: t, index: o }) => [
            n("div", {
              "data-cy-legend-item": "",
              onClick: (f) => X(t.id),
              style: r(`opacity:${C.value.includes(t.id) ? 0.5 : 1}`)
            }, i(t.name) + ": " + i(h(Q)(
              e.value.style.chart.layout.bars.dataLabels.value.formatter,
              t.value,
              h(I)({
                p: e.value.style.chart.legend.prefix,
                v: t.value,
                s: e.value.style.chart.legend.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: o }
            )), 13, ft)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])
      ], 512)) : m("", !0),
      W.value ? (s(), d("svg", {
        key: 3,
        xmlns: h(et),
        class: D({ "vue-data-ui-fullscreen--on": E.value, "vue-data-ui-fulscreen--off": !E.value }),
        viewBox: `0 0 ${y.value.width <= 0 ? 10 : y.value.width} ${u.value.fullHeight <= 0 ? 10 : u.value.fullHeight}`,
        style: r(`max-width:100%;overflow:visible;background:${e.value.style.chart.backgroundColor};color:${e.value.style.chart.color}`)
      }, [
        (s(!0), d(U, null, H(B.value, (t, o) => (s(), d("linearGradient", {
          x1: "0%",
          y1: "0%",
          x2: "100%",
          y2: "0%",
          id: `vertical_bar_gradient_${V.value}_${o}`
        }, [
          n("stop", {
            offset: "0%",
            "stop-color": t.color
          }, null, 8, _t),
          n("stop", {
            offset: "100%",
            "stop-color": `${h(tt)(t.color, 0.03)}${h(se)[100 - e.value.style.chart.layout.bars.gradientIntensity]}`
          }, null, 8, xt)
        ], 8, mt))), 256)),
        (s(!0), d(U, null, H(B.value, (t, o) => (s(), d("g", null, [
          n("rect", {
            x: h(S)(O.value ? u.value.left + u.value.width / 2 - (t.sign === 1 ? 0 : P(t.value) <= 0 ? 1e-4 : P(t.value)) : u.value.left),
            y: u.value.top + (g.value + c.value) * o,
            width: h(S)(P(t.value) <= 0 ? 1e-4 : P(t.value)),
            height: c.value <= 0 ? 1e-4 : c.value,
            fill: e.value.style.chart.layout.bars.underlayerColor,
            rx: e.value.style.chart.layout.bars.borderRadius,
            class: D({ animated: e.value.useCssAnimation })
          }, null, 10, kt)
        ]))), 256)),
        (s(!0), d(U, null, H(B.value, (t, o) => (s(), d("g", null, [
          n("rect", {
            x: h(S)(O.value ? u.value.left + u.value.width / 2 - (t.sign === 1 ? 0 : P(t.value) <= 0 ? 1e-4 : P(t.value)) : u.value.left),
            y: u.value.top + (g.value + c.value) * o,
            width: h(S)(P(t.value) <= 0 ? 1e-4 : P(t.value)),
            height: c.value <= 0 ? 1e-4 : c.value,
            fill: e.value.style.chart.layout.bars.useGradient ? `url(#vertical_bar_gradient_${V.value}_${o})` : `${t.color}${h(se)[e.value.style.chart.layout.bars.fillOpacity]}`,
            rx: e.value.style.chart.layout.bars.borderRadius,
            stroke: e.value.style.chart.layout.bars.useStroke ? t.color : "none",
            "stroke-width": e.value.style.chart.layout.bars.useStroke ? e.value.style.chart.layout.bars.strokeWidth : 0,
            class: D({ animated: e.value.useCssAnimation })
          }, null, 10, $t),
          (!t.isChild || t.isLastChild) && e.value.style.chart.layout.separators.show && o !== B.value.length - 1 ? (s(), d("line", {
            key: 0,
            x1: 0,
            x2: u.value.left,
            y1: c.value + g.value / 2 + u.value.top + (g.value + c.value) * o,
            y2: c.value + g.value / 2 + u.value.top + (g.value + c.value) * o,
            stroke: e.value.style.chart.layout.separators.color,
            "stroke-width": e.value.style.chart.layout.separators.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, wt)) : m("", !0),
          O.value && e.value.style.chart.layout.separators.show ? (s(), d("line", {
            key: 1,
            x1: u.value.left + u.value.width / 2,
            x2: u.value.left + u.value.width / 2,
            y1: u.value.top,
            y2: u.value.bottom,
            stroke: e.value.style.chart.layout.separators.color,
            "stroke-width": e.value.style.chart.layout.separators.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Ct)) : m("", !0),
          n("text", {
            x: O.value ? u.value.left + u.value.width / 2 + (t.sign === 1 ? -12 : 12) + (t.sign === 1 ? -e.value.style.chart.layout.bars.dataLabels.offsetX : e.value.style.chart.layout.bars.dataLabels.offsetX) : Re(t.value) + 3 + e.value.style.chart.layout.bars.dataLabels.offsetX,
            y: u.value.top + (g.value + c.value) * o + c.value / 2 + e.value.style.chart.layout.bars.dataLabels.fontSize / 2,
            "text-anchor": !O.value || t.sign === -1 ? "start" : "end",
            "font-size": e.value.style.chart.layout.bars.dataLabels.fontSize,
            fill: e.value.style.chart.layout.bars.dataLabels.color,
            "font-weight": e.value.style.chart.layout.bars.dataLabels.bold ? "bold" : "normal"
          }, i(xe(t.value, t, o, t.sign)), 9, Tt),
          (t.isChild || !t.hasChildren) && e.value.style.chart.layout.bars.nameLabels.show ? (s(), d("text", {
            key: 2,
            "text-anchor": "end",
            x: u.value.left - 3 + e.value.style.chart.layout.bars.nameLabels.offsetX,
            y: u.value.top + (g.value + c.value) * o + c.value / 2 + e.value.style.chart.layout.bars.nameLabels.fontSize / 2,
            "font-size": e.value.style.chart.layout.bars.nameLabels.fontSize,
            fill: e.value.style.chart.layout.bars.nameLabels.color,
            "font-weight": e.value.style.chart.layout.bars.nameLabels.bold ? "bold" : "normal"
          }, i(t.name), 9, Lt)) : m("", !0),
          t.isChild && t.childIndex === 0 && e.value.style.chart.layout.bars.parentLabels.show ? (s(), d("text", {
            key: 3,
            x: 3 + e.value.style.chart.layout.bars.parentLabels.offsetX,
            y: A(t, o).y,
            "font-size": e.value.style.chart.layout.bars.parentLabels.fontSize,
            fill: e.value.style.chart.layout.bars.parentLabels.color,
            "font-weight": e.value.style.chart.layout.bars.parentLabels.bold ? "bold" : "normal",
            "text-anchor": "start"
          }, i(A(t, o).name), 9, Nt)) : m("", !0),
          t.isChild && t.childIndex === 0 && e.value.style.chart.layout.bars.parentLabels.show ? (s(), d("text", {
            key: 4,
            x: 3 + e.value.style.chart.layout.bars.parentLabels.offsetX,
            y: A(t, o).y + e.value.style.chart.layout.bars.parentLabels.fontSize + 6,
            "font-size": e.value.style.chart.layout.bars.parentLabels.fontSize,
            fill: e.value.style.chart.layout.bars.parentLabels.color,
            "font-weight": e.value.style.chart.layout.bars.dataLabels.bold ? "bold" : "normal",
            "text-anchor": "start"
          }, i(xe(A(t, o).value), A(t, o), o, t.parentSign || t.sign), 9, Pt)) : m("", !0),
          n("rect", {
            "data-cy-trap": "",
            x: 0,
            y: u.value.top + (g.value + c.value) * o - g.value / 2,
            width: y.value.width <= 0 ? 1e-4 : y.value.width,
            height: c.value + g.value <= 0 ? 1e-4 : c.value + g.value,
            fill: le.value === t.id ? `${e.value.style.chart.layout.highlighter.color}${h(se)[e.value.style.chart.layout.highlighter.opacity]}` : "transparent",
            onMouseenter: (f) => Ae(t, o),
            onMouseleave: l[1] || (l[1] = (f) => {
              Me.value = null, Z.value = !1, le.value = null;
            })
          }, null, 40, St)
        ]))), 256)),
        k(a.$slots, "svg", { svg: y.value }, void 0, !0)
      ], 14, bt)) : m("", !0),
      a.$slots.watermark ? (s(), d("div", Vt, [
        k(a.$slots, "watermark", q(K({ isPrinting: h(de) || h(ce) })), void 0, !0)
      ])) : m("", !0),
      W.value ? m("", !0) : (s(), ne(vt, {
        key: 5,
        config: {
          type: "verticalBar",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            verticalBar: {
              axis: {
                color: "#CCCCCC"
              },
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.chart.legend.show && e.value.style.chart.legend.position === "bottom" ? (s(), d("div", {
        key: 6,
        ref_key: "chartLegend",
        ref: te
      }, [
        G(Le, {
          legendSet: z.value,
          config: be.value,
          onClickMarker: l[2] || (l[2] = ({ legend: t }) => X(t.id))
        }, {
          item: x(({ legend: t, index: o }) => [
            n("div", {
              onClick: (f) => X(t.id),
              style: r(`opacity:${C.value.includes(t.id) ? 0.5 : 1}`)
            }, i(t.name) + ": " + i(h(Q)(
              e.value.style.chart.layout.bars.dataLabels.value.formatter,
              t.value,
              h(I)({
                p: e.value.style.chart.legend.prefix,
                v: t.value,
                s: e.value.style.chart.legend.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: o }
            )), 13, zt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])
      ], 512)) : m("", !0),
      k(a.$slots, "legend", { legend: z.value }, void 0, !0),
      G(ct, {
        show: $.value.showTooltip && Z.value && C.value.length < N.dataset.length,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        fontSize: e.value.style.chart.tooltip.fontSize,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: R.value,
        content: ee.value,
        isCustom: e.value.style.chart.tooltip.customFormat && typeof e.value.style.chart.tooltip.customFormat == "function"
      }, {
        "tooltip-before": x(() => [
          k(a.$slots, "tooltip-before", q(K({ ...oe.value })), void 0, !0)
        ]),
        "tooltip-after": x(() => [
          k(a.$slots, "tooltip-after", q(K({ ...oe.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      W.value ? (s(), ne(pt, {
        key: 7,
        hideDetails: "",
        config: {
          open: $.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: x(() => [
          n("div", {
            ref_key: "tableContainer",
            ref: ye,
            class: "vue-ui-vertical-bar-table"
          }, [
            n("div", Ft, [
              n("div", {
                role: "button",
                tabindex: "0",
                style: r(`width:32px; position: absolute; top: 0; right:4px; padding: 0 0px; display: flex; align-items:center;justify-content:center;height: 36px; width: 32px; cursor:pointer; background:${e.value.table.th.backgroundColor};`),
                onClick: l[3] || (l[3] = (t) => $.value.showTable = !1),
                onKeypress: l[4] || (l[4] = je((t) => $.value.showTable = !1, ["enter"]))
              }, [
                G(ht, {
                  name: "close",
                  stroke: e.value.table.th.color,
                  "stroke-width": 2
                }, null, 8, ["stroke"])
              ], 36),
              n("div", {
                style: { width: "100%", "container-type": "inline-size" },
                class: D({ "vue-ui-responsive": ge.value })
              }, [
                n("table", Mt, [
                  n("caption", {
                    style: r({ backgroundColor: e.value.table.th.backgroundColor, color: e.value.table.th.color, outline: e.value.table.th.outline }),
                    class: "vue-ui-data-table__caption"
                  }, [
                    Ye(i(e.value.style.chart.title.text) + " ", 1),
                    e.value.style.chart.title.subtitle.text ? (s(), d("span", It, i(e.value.style.chart.title.subtitle.text), 1)) : m("", !0)
                  ], 4),
                  n("thead", null, [
                    n("tr", {
                      role: "row",
                      style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color}`)
                    }, [
                      (s(!0), d(U, null, H(w.value.head, (t) => (s(), d("th", {
                        style: r(`outline:${e.value.table.th.outline}`)
                      }, [
                        n("div", Bt, i(t), 1)
                      ], 4))), 256))
                    ], 4),
                    n("tr", null, [
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline};text-align:right;padding-right:5px;font-weight:bold`)
                      }, "∑ " + i(e.value.table.td.prefix) + i(isNaN(T.value) ? "" : T.value.toFixed(e.value.table.td.roundingValue)) + i(e.value.table.td.suffix), 5),
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline};text-align:right;padding-right:5px;font-weight:bold`)
                      }, "100%", 4),
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4),
                      n("th", {
                        style: r(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                      }, null, 4)
                    ])
                  ]),
                  n("tbody", null, [
                    (s(!0), d(U, null, H(w.value.body, (t, o) => (s(), d("tr", {
                      class: D({ "vue-ui-data-table__tbody__row": !0, "vue-ui-data-table__tbody__row-even": o % 2 === 0, "vue-ui-data-table__tbody__row-odd": o % 2 !== 0 }),
                      style: r(`background:${e.value.table.td.backgroundColor};color:${e.value.table.td.color}`)
                    }, [
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline};font-variant-numeric: tabular-nums;`),
                        "data-cell": w.value.head[0] ?? ""
                      }, [
                        n("div", Dt, [
                          t.color ? (s(), d("span", {
                            key: 0,
                            style: r(`color:${t.color};margin-right:3px`)
                          }, "⬤", 4)) : m("", !0),
                          n("span", null, i(t.parentName), 1)
                        ])
                      ], 12, Ot),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[1] ?? ""
                      }, [
                        n("div", Xt, i(e.value.table.td.prefix) + i(["", NaN, void 0].includes(t.parentValue) ? "" : t.parentValue.toFixed(e.value.table.td.roundingValue)) + i(e.value.table.td.suffix), 1)
                      ], 12, Rt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[2] ?? ""
                      }, [
                        n("div", Et, i(["", NaN, void 0].includes(t.percentageToTotal) ? "" : `${(t.percentageToTotal * 100).toFixed(e.value.table.td.roundingPercentage)}%`), 1)
                      ], 12, At),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[3] ?? ""
                      }, [
                        n("div", Ut, i(t.childName), 1)
                      ], 12, Gt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[4] ?? ""
                      }, [
                        n("div", Wt, i(e.value.table.td.prefix) + i(["", NaN, void 0].includes(t.childValue) ? "" : t.childValue.toFixed(e.value.table.td.roundingValue)) + i(e.value.table.td.suffix), 1)
                      ], 12, Ht),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[5] ?? ""
                      }, [
                        n("div", Yt, i(["", NaN, void 0].includes(t.childPercentageToParent) ? "" : `${(t.childPercentageToParent * 100).toFixed(e.value.table.td.roundingPercentage)}%`), 1)
                      ], 12, jt),
                      n("td", {
                        class: "vue-ui-data-table__tbody__td",
                        style: r(`outline:${e.value.table.td.outline}`),
                        "data-cell": w.value.head[6] ?? ""
                      }, [
                        n("div", Kt, i(["", NaN, void 0].includes(t.childPercentageToTotal) ? "" : `${(t.childPercentageToTotal * 100).toFixed(e.value.table.td.roundingPercentage)}%`), 1)
                      ], 12, qt)
                    ], 6))), 256))
                  ])
                ])
              ], 2)
            ])
          ], 512)
        ]),
        _: 1
      }, 8, ["config"])) : m("", !0)
    ], 14, gt));
  }
}, da = /* @__PURE__ */ yt(Jt, [["__scopeId", "data-v-e114e098"]]);
export {
  da as default
};
