import { p as K } from "./pdf-97UbtKC2.js";
import { U as Q, s as j } from "./usePrinter-Dj50NAxo.js";
import { c as J, a as $, t as ee, w as te, p as ae, u as ie, S as q, M as P, f as Z, H as le, E as re, i as se, Y as ne, V as oe, Z as ce, s as he, _ as de, d as ue, A as ge, b as fe, q as me, P as Ne, $ as Ie, r as be, e as xe, y as _e, K as Fe, x as ye, a0 as Ae, o as Le, v as ke, D as Se, z as Ce } from "./index-C8SH0f2u.js";
import { D as we } from "./DataTable-CKdV-L0e.js";
import { _ as Oe } from "./Title-DZjnxQdN.js";
import { _ as ve, u as Ge } from "./Tooltip--kgFEVZs.js";
import { _ as ze } from "./Shape-Bo8ZjViG.js";
import Me from "./BaseIcon-kBIAYqUO.js";
import pe from "./vue-ui-table-sparkline-C0v2r4Kf.js";
import Pe from "./vue-ui-skeleton-B4eWLjH3.js";
import { S as Te } from "./Slicer-4nGKvUYF.js";
import Ve from "./vue-ui-accordion-YHleIgkV.js";
import { u as U } from "./useNestedProp-lS_T5lM3.js";
import { resolveComponent as T, openBlock as l, createElementBlock as r, normalizeClass as p, normalizeStyle as A, createVNode as X, createCommentVNode as c, createBlock as V, createSlots as Re, withCtx as z, renderSlot as O, normalizeProps as B, guardReactiveProps as Y, createElementVNode as u, Fragment as m, renderList as b, toDisplayString as k, withDirectives as De, vModelCheckbox as He, createTextVNode as Ee } from "vue";
import { _ as We } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Be = J(), Ye = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: we,
    Shape: ze,
    Title: Oe,
    Tooltip: ve,
    UserOptions: Q,
    BaseIcon: Me,
    TableSparkline: pe,
    Skeleton: Pe,
    Slicer: Te,
    Accordion: Ve
  },
  data() {
    this.dataset.forEach((h, f) => {
      [null, void 0].includes(h.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: f
      });
    });
    const i = Math.max(...this.dataset.map((h) => h.series.length)), s = {
      start: 0,
      end: i
    };
    return {
      themePalettes: $,
      themes: ee,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: te,
      useSafeValues: !0,
      palette: ae,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      slicer: s,
      __to__: null,
      maxX: i,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Be,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null
    };
  },
  computed: {
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const i = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), s = Math.max(...i.map((t) => t.series.length)), h = [];
      for (let t = 0; t < s; t += 1)
        h.push(i.map((e) => e.series[t] || 0).reduce((e, I) => (e || 0) + (I || 0), 0));
      const f = Math.min(...h);
      return h.map((t) => t + (f < 0 ? Math.abs(f) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const i = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), s = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), h = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), f = [...i, ...s, ...h].flatMap((t) => t).length;
      return [...i, ...s, ...h].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / f * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((I) => ({
          y: I >= 0 ? t.zero - t.individualHeight * (I / t.max) : t.zero + t.individualHeight * Math.abs(I) / t.max,
          value: I
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const i = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(i, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        const i = ie().vue_ui_xy;
        if (!Object.keys(this.config || {}).length)
          return i;
        const s = this.useNestedProp({
          userConfig: this.config,
          defaultConfig: i
        });
        return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, s.theme ? {
          ...U({
            userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
            defaultConfig: s
          }),
          customPalette: this.themePalettes[s.theme] || this.palette
        } : s;
      },
      set: function(i) {
        return i;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((i) => i.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const i = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...i, span: i.from === i.to ? 1 : i.to < i.from ? 0 : i.to - i.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((i, s) => ({
        ...i,
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((i, s) => ({
        ...i,
        series: i.series.map((h) => this.isSafeValue(h) ? h : null).slice(this.slicer.start, this.slicer.end),
        color: this.convertColorToHex(i.color ? i.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((i, s) => ({
        ...i,
        series: i.series.map((h) => h + this.relativeZero),
        absoluteValues: i.series
      })).filter((i) => !this.segregatedSeries.includes(i.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((i) => {
        const s = i.absoluteValues.map((h) => [void 0, null].includes(h) ? 0 : h);
        return {
          id: i.id,
          name: i.name,
          color: i.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((i, s) => ({
        absoluteIndex: s,
        ...i,
        series: i.series.map((h) => h + this.relativeZero),
        absoluteValues: i.series,
        segregate: () => this.segregate(i),
        isSegregated: this.segregatedSeries.includes(i.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "bar").map((i, s) => {
        this.checkAutoScaleError(i);
        const h = Math.min(...i.absoluteValues.filter((d) => ![null, void 0].includes(d))), f = Math.max(...i.absoluteValues.filter((d) => ![null, void 0].includes(d))), e = {
          ratios: i.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - h) / (f - h)),
          valueMin: h,
          valueMax: f < 0 ? 0 : f
        }, I = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues.filter((d) => ![void 0, null].includes(d))) > 0 ? 0 : Math.min(...i.absoluteValues.filter((d) => ![null, void 0].includes(d)))
        }, w = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, L = 1.0000001, N = this.calculateNiceScaleWithExactExtremes(I.min, I.max === I.min ? I.max * L : I.max, w), y = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * L : e.valueMax, w), M = N.min >= 0 ? 0 : Math.abs(N.min), S = 0, G = N.max + M, v = y.max + Math.abs(S), x = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, a = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, o = this.drawingArea.bottom - x - a * M / G, n = this.drawingArea.bottom - x - a * S / v, g = this.absoluteDataset.filter((d) => d.type === "bar").filter((d) => !this.segregatedSeries.includes(d.id)).length, R = i.series.map((d, _) => {
          const E = this.mutableConfig.useIndividualScale ? (i.absoluteValues[_] + M) / G : this.ratioToMax(d), W = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * _ : this.drawingArea.left + this.slot.bar * s + this.slot.bar * _ * g - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(x),
            individualHeight: this.checkNaN(a),
            x: this.checkNaN(W),
            y: this.drawingArea.bottom - x - a * E,
            value: i.absoluteValues[_],
            zeroPosition: this.checkNaN(o),
            individualMax: this.checkNaN(G),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[_] || ""
          };
        }), H = i.absoluteValues.map((d) => y.min >= 0 ? (d - Math.abs(y.min)) / (y.max - Math.abs(y.min)) : (d + Math.abs(y.min)) / (y.max + Math.abs(y.min))), D = i.series.map((d, _) => {
          const E = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * _ : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * _ * this.absoluteDataset.filter((W) => W.type === "bar").filter((W) => !this.segregatedSeries.includes(W.id)).length;
          return {
            yOffset: this.checkNaN(x),
            individualHeight: this.checkNaN(a),
            x: this.checkNaN(E),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(x) - (this.checkNaN(a) * H[_] || 0)),
            value: i.absoluteValues[_],
            zeroPosition: this.checkNaN(o),
            individualMax: this.checkNaN(G),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[_] || ""
          };
        }), F = N.ticks.map((d) => ({
          y: d >= 0 ? o - a * (d / G) : o + a * Math.abs(d) / G,
          value: d
        })), C = y.ticks.map((d) => {
          const _ = (d - y.min) / (y.max - y.min);
          return {
            y: d >= 0 ? n - a * _ : n + a * _,
            value: d
          };
        });
        return {
          ...i,
          yOffset: x,
          autoScaleYLabels: C,
          individualHeight: a,
          scaleYLabels: i.autoScaling ? C : F,
          individualScale: i.autoScaling ? y : N,
          individualMax: i.autoScaling ? v : G,
          zeroPosition: i.autoScaling ? n : o,
          plots: i.autoScaling ? D : R
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((i) => !this.segregatedSeries.includes(i.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "line").map((i) => {
        this.checkAutoScaleError(i);
        const s = Math.min(...i.absoluteValues.filter((d) => ![void 0, null].includes(d))), h = Math.max(...i.absoluteValues.filter((d) => ![void 0, null].includes(d))) || 1, t = {
          ratios: i.absoluteValues.filter((d) => ![null, void 0].includes(d)).map((d) => (d - s) / (h - s)),
          valueMin: s,
          valueMax: h
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || (Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues))
        }, I = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, w = 1.0000001, L = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * w : e.max, I), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * w : t.valueMax, I), y = L.min >= 0 ? 0 : Math.abs(L.min), M = 0, S = L.max + Math.abs(y), G = N.max + Math.abs(M), v = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, x = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, a = this.drawingArea.bottom - v - x * y / S, o = this.drawingArea.bottom - v - x * M / G, n = i.series.map((d, _) => {
          const E = this.mutableConfig.useIndividualScale ? (i.absoluteValues[_] + Math.abs(y)) / S : this.ratioToMax(d);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * _),
            y: this.checkNaN(this.drawingArea.bottom - v - x * E),
            value: i.absoluteValues[_],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[_] || ""
          };
        }), g = i.absoluteValues.map((d) => N.min >= 0 ? (d - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (d + Math.abs(N.min)) / (N.max + Math.abs(N.min))), R = i.series.map((d, _) => {
          if (![void 0, null].includes(i.absoluteValues[_]))
            return {
              x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * _),
              y: this.checkNaN(this.drawingArea.bottom - v - (x * g[_] || 0)),
              value: i.absoluteValues[_],
              comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[_] || ""
            };
        }), H = this.createSmoothPath(n), D = this.createSmoothPath(R), F = L.ticks.map((d) => ({
          y: d >= 0 ? a - x * (d / S) : a + x * Math.abs(d) / S,
          value: d
        })), C = N.ticks.map((d) => {
          const _ = (d - N.min) / (N.max - N.min);
          return {
            y: d >= 0 ? o - x * _ : o + x * _,
            value: d
          };
        });
        return {
          ...i,
          yOffset: v,
          autoScaleYLabels: C,
          individualHeight: x,
          scaleYLabels: i.autoScaling ? C : F,
          individualScale: i.autoScaling ? N : L,
          individualMax: i.autoScaling ? G : S,
          zeroPosition: i.autoScaling ? o : a,
          curve: i.autoScaling ? D : H,
          plots: i.autoScaling ? R : n,
          area: i.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(i.autoScaling ? R : n, i.autoScaling ? o : a) : this.createArea(n) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "plot").map((i) => {
        this.checkAutoScaleError(i);
        const s = Math.min(...i.absoluteValues.filter((F) => ![null, void 0].includes(F))), h = Math.max(...i.absoluteValues.filter((F) => ![null, void 0].includes(F))) || 1, t = {
          ratios: i.absoluteValues.filter((F) => ![null, void 0].includes(F)).map((F) => (F - s) / (h - s)),
          valueMin: s,
          valueMax: h
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues)
        }, I = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, w = 1.0000001, L = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * w : e.max, I), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * w : t.valueMax, I), y = L.min >= 0 ? 0 : Math.abs(L.min), M = 0, S = L.max + y, G = N.max + Math.abs(M), v = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, x = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, a = this.drawingArea.bottom - v - x * y / S, o = this.drawingArea.bottom - v - x * M / G, n = i.series.map((F, C) => {
          const d = this.mutableConfig.useIndividualScale ? (i.absoluteValues[C] + Math.abs(y)) / S : this.ratioToMax(F);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * C),
            y: this.checkNaN(this.drawingArea.bottom - v - x * d),
            value: i.absoluteValues[C],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[C] || ""
          };
        }), g = i.absoluteValues.map((F) => N.min >= 0 ? (F - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (F + Math.abs(N.min)) / (N.max + Math.abs(N.min))), R = i.series.map((F, C) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * C),
          y: this.checkNaN(this.drawingArea.bottom - v - (x * g[C] || 0)),
          value: i.absoluteValues[C],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[C] || ""
        })), H = L.ticks.map((F) => ({
          y: F >= 0 ? a - x * (F / S) : a + x * Math.abs(F) / S,
          value: F
        })), D = N.ticks.map((F) => {
          const C = (F - N.min) / (N.max - N.min);
          return {
            y: F >= 0 ? o - x * C : o + x * C,
            value: F
          };
        });
        return {
          ...i,
          yOffset: v,
          autoScaleYLabels: D,
          individualHeight: x,
          scaleYLabels: i.autoScaling ? D : H,
          individualScale: i.autoScaling ? N : L,
          individualMax: i.autoScaling ? G : S,
          zeroPosition: i.autoScaling ? o : a,
          plots: i.autoScaling ? R : n
        };
      });
    },
    drawingArea() {
      const i = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + i,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + i)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((i) => !this.segregatedSeries.includes(i.id)).map((i) => Math.max(...i.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const i = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return i > 0 ? 0 : i;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      return this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((i) => i.type === "bar").filter((i) => !this.segregatedSeries.includes(i.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const i = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / i - this.barPeriodGap * i;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((i) => i !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const i = this.relativeDataset.map((h) => ({
        label: h.name,
        color: h.color,
        type: h.type
      })), s = [];
      return this.timeLabels.forEach((h, f) => {
        const t = [h];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[f]) ? Number(e.absoluteValues[f].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(t);
      }), { head: i, body: s };
    },
    dataTable() {
      const i = [""].concat(this.relativeDataset.map((t) => t.name)).concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>');
      let s = [];
      for (let t = 0; t < this.maxSeries; t += 1) {
        const e = this.relativeDataset.map((I) => I.absoluteValues[t] ?? 0).reduce((I, w) => I + w, 0);
        s.push([this.timeLabels[t] ?? "-"].concat(this.relativeDataset.map((I) => (I.absoluteValues[t] ?? 0).toFixed(this.FINAL_CONFIG.table.rounding))).concat((e ?? 0).toFixed(this.FINAL_CONFIG.table.rounding)));
      }
      const h = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, f = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((t) => t.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: i, body: s, config: h, colNames: f };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((i) => ({
        shape: i.shape || null,
        name: i.name,
        color: i.color,
        type: i.type,
        value: i.absoluteValues.find((s, h) => h === this.selectedSerieIndex),
        comments: i.comments || []
      }));
    },
    tooltipContent() {
      let i = "", s = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const h = this.timeLabels[this.selectedSerieIndex], f = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(f) && this.functionReturnsString(() => f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (h && (i += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${h}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", I = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? I = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" />` : t.shape === "triangle" ? I = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "square" ? I = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "diamond" ? I = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "pentagon" ? I = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "hexagon" ? I = `<path d="${P({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "star" && (I = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="3" x="0" y="6" stroke="none" height="4" width="20" fill="${t.color}" />${I}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${P({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          i += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: this.FINAL_CONFIG.chart.labels.prefix,
              v: t.value,
              s: this.FINAL_CONFIG.chart.labels.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${Z({
            v: this.checkNaN(Math.abs(t.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${i}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((i) => ({
        y: i >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(i) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(i)),
        value: i
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    if (this.objectIsEmpty(this.dataset) ? this.error({
      componentName: "VueUiXy",
      type: "dataset"
    }) : this.dataset.forEach((i, s) => {
      [null, void 0].includes(i.name) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "name (string)",
        index: s
      });
    }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((i) => {
      i.series.forEach((s, h) => {
        this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${i.name}' contains the value '${s}' at index ${h}.
'${s}' was converted to null to allow the chart to display.`);
      });
    }), document.addEventListener("mousemove", (i) => {
      this.clientPosition = {
        x: i.clientX,
        y: i.clientY
      };
    }), this.mutableConfig = {
      dataLabels: {
        show: !0
      },
      showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
      showTable: this.FINAL_CONFIG.showTable === !0,
      isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
      useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
    }, this.FINAL_CONFIG.responsive) {
      const s = this.$refs.chart.parentNode, { height: h, width: f } = s.getBoundingClientRect();
      let t = null, e = 0;
      this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
      let I = null, w = 0;
      this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (I = this.$refs.chartSlicer.$el, w = I.getBoundingClientRect().height);
      let L = null, N = 0;
      this.FINAL_CONFIG.chart.legend.show && (L = this.$refs.chartLegend, N = L.getBoundingClientRect().height), this.height = h - e - N - w, this.width = f, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((M) => {
        for (const S of M)
          this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (w = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (N = this.$refs.chartLegend.getBoundingClientRect().height), this.height = S.contentBoxSize[0].blockSize - e - N - w - 24, this.width = S.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
      }).observe(s);
    } else
      this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
  },
  methods: {
    abbreviate: le,
    adaptColorToBackground: re,
    applyDataLabel: se,
    assignStackRatios: ne,
    calcLinearProgression: oe,
    calculateNiceScaleWithExactExtremes: ce,
    checkNaN: he,
    closestDecimal: de,
    convertColorToHex: ue,
    convertConfigColors: ge,
    convertCustomPalette: fe,
    createCsvContent: me,
    createSmoothPath: Ne,
    createTSpans: Ie,
    dataLabel: Z,
    downloadCsv: be,
    error: xe,
    functionReturnsString: _e,
    hasDeepProperty: Fe,
    img: j,
    isFunction: ye,
    isSafeValue: Ae,
    objectIsEmpty: Le,
    pdf: K,
    shiftHue: ke,
    translateSize: Se,
    treeShake: Ce,
    useMouse: Ge,
    useNestedProp: U,
    selectMinimapIndex(i) {
      this.selectedMinimapIndex = i;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(i) {
      i.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(i) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const s = { x: i[0].x, y: this.zero }, h = { x: i.at(-1).x, y: this.zero }, f = [];
      return i.forEach((t) => {
        f.push(`${t.x},${t.y} `);
      }), [s.x, s.y, ...f, h.x, h.y].toString();
    },
    createIndividualArea(i, s) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const h = { x: i[0] ? i[0].x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: s }, f = { x: i.at(-1) ? i.at(-1).x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: s }, t = [];
      return i.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [h.x, h.y, ...t, f.x, f.y].toString();
    },
    createStar: q,
    createPolygonPath: P,
    fillArray(i, s) {
      let h = Array(i).fill(0);
      for (let f = 0; f < s.length && f < i; f += 1)
        h[f] = s[f];
      return h;
    },
    refreshSlicer() {
      this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((i) => i.series.length))
      }, this.slicerStep += 1;
    },
    calcRectHeight(i) {
      return i.value >= 0 ? this.checkNaN(this.zero - i.y <= 0 ? 1e-5 : this.zero - i.y) : this.checkNaN(i.y - this.zero <= 0 ? 1e-5 : i.y - this.zero);
    },
    calcIndividualHeight(i) {
      return i.value >= 0 ? this.checkNaN(i.zeroPosition - i.y <= 0 ? 1e-5 : i.zeroPosition - i.y) : this.checkNaN(i.y - i.zeroPosition <= 0 ? 1e-5 : i.zeroPosition - i.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(i) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? i.x + this.drawingArea.width / this.maxSeries * 0.05 : i.x + this.slot.bar / 2;
    },
    calcRectY(i) {
      return i.value >= 0 ? i.y : this.zero;
    },
    calcIndividualRectY(i) {
      return i.value >= 0 ? i.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(i.zeroPosition) ? 0 : i.zeroPosition;
    },
    canShowValue(i) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(i);
    },
    findClosestValue(i, s) {
      let h = s[0], f = Math.abs(i - s[0]);
      for (let t = 1; t < s.length; t += 1) {
        const e = Math.abs(i - s[t]);
        e < f && s[t] < i && (h = s[t], f = e);
      }
      return h;
    },
    ratioToMax(i) {
      return i / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(i) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[i]) ? null : s.absoluteValues[i],
            color: s.color,
            type: s.type
          })),
          index: i,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((i) => ({
        values: i.absoluteValues,
        color: i.color,
        name: i.name,
        type: i.type
      }));
    },
    segregate(i) {
      if (this.segregatedSeries.includes(i.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== i.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(i.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(i, s = null) {
      this.isTooltip = i, i ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(i) {
      this.isFullscreen = i, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.__to__ = setTimeout(() => {
        this.pdf({
          domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
          fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
        }).finally(() => {
          this.isPrinting = !1;
        });
      }, 100);
    },
    generateCsv() {
      const i = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], h = this.table.body, f = i.concat([s]).concat(h), t = this.createCsvContent(f);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.__to__ = setTimeout(() => {
        this.img({
          domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
          fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
          format: "png"
        }).finally(() => {
          this.isImaging = !1;
        });
      }, 100);
    }
  }
}, Xe = ["id"], qe = ["viewBox"], Ze = { key: 0 }, Ue = { class: "vue-ui-xy-grid" }, Je = ["stroke", "x1", "x2", "y1", "y2"], Ke = ["stroke", "x1", "x2", "y1", "y2"], Qe = { key: 1 }, je = ["x1", "x2", "y1", "y2", "stroke"], $e = ["x1", "x2", "y1", "y2", "stroke"], et = ["x1", "x2", "y1", "y2", "stroke"], tt = { key: 3 }, at = ["x1", "x2", "y1", "y2", "stroke"], it = ["id"], lt = ["stop-color"], rt = ["stop-color"], st = ["stop-color"], nt = ["id"], ot = ["stop-color"], ct = ["stop-color"], ht = ["stop-color"], dt = ["id"], ut = ["stop-color"], gt = ["stop-color"], ft = ["id"], mt = ["stop-color"], Nt = ["stop-color"], It = ["id"], bt = ["stop-color"], xt = ["stop-color"], _t = ["x", "y", "height", "width", "fill"], Ft = ["x", "y", "width"], yt = ["x", "y", "height", "width", "fill"], At = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Lt = ["width", "x", "y"], kt = { key: 0 }, St = ["id"], Ct = ["fill"], wt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Ot = ["x", "y", "font-size", "fill"], vt = ["stroke", "x1", "x2", "y1", "y2"], Gt = { key: 2 }, zt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Mt = ["y", "width", "height", "fill"], pt = ["x", "y", "width", "height", "fill"], Pt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Tt = { key: 4 }, Vt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Rt = ["fill", "font-size", "transform"], Dt = ["x1", "x2", "y1", "y2", "stroke"], Ht = ["x", "y", "font-size", "fill"], Et = ["x1", "x2", "y1", "y2", "stroke"], Wt = ["x", "y", "font-size", "fill"], Bt = ["width", "x", "y"], Yt = { style: { width: "100%" } }, Xt = { key: 0 }, qt = ["id"], Zt = ["fill"], Ut = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Jt = ["x", "y", "font-size", "fill"], Kt = ["d", "stroke", "stroke-width", "stroke-dasharray"], Qt = { key: 1 }, jt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], $t = { key: 0 }, ea = ["d", "fill"], ta = ["d", "fill"], aa = ["d", "stroke", "stroke-width", "stroke-dasharray"], ia = { key: 2 }, la = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ra = ["width", "x", "y"], sa = { style: { width: "100%" } }, na = { key: 3 }, oa = ["id"], ca = ["fill"], ha = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], da = ["x", "y", "font-size", "fill"], ua = { key: 5 }, ga = ["x", "y", "font-size", "fill"], fa = ["x", "y", "font-size", "fill", "font-weight"], ma = { key: 6 }, Na = ["x", "y", "font-size", "fill"], Ia = ["x", "y"], ba = ["x", "y"], xa = { key: 7 }, _a = ["x", "y", "font-size", "fill"], Fa = ["x", "y"], ya = ["x", "y"], Aa = ["x", "y", "font-size", "fill", "innerHTML"], La = ["x", "y", "font-size", "fill", "innerHTML"], ka = ["x", "y", "font-size", "fill", "innerHTML"], Sa = ["x", "y", "font-size", "fill", "innerHTML"], Ca = ["x", "y", "width", "height", "fill", "onMouseenter"], wa = ["font-size", "fill", "transform"], Oa = ["x", "y", "font-size", "fill"], va = { key: 9 }, Ga = ["text-anchor", "font-size", "fill", "transform"], za = ["x", "y", "height", "width", "onMouseenter", "onClick"], Ma = { key: 10 }, pa = ["x", "y"], Pa = ["cx", "cy", "r", "fill"], Ta = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Va = ["onClick"], Ra = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Da = ["fill"], Ha = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Ea = ["fill"], Wa = {
  key: 7,
  ref: "chartLegend"
}, Ba = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, Ya = ["innerHTML"];
function Xa(i, s, h, f, t, e) {
  const I = T("Title"), w = T("UserOptions"), L = T("Shape"), N = T("Skeleton"), y = T("Slicer"), M = T("Tooltip"), S = T("BaseIcon"), G = T("TableSparkline"), v = T("DataTable"), x = T("Accordion");
  return l(), r("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: p(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: A(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;${e.FINAL_CONFIG.chart.title.text ? "" : "padding-top:36px"};font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`)
  }, [
    e.FINAL_CONFIG.chart.title.show ? (l(), r("div", {
      key: 0,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: A(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      X(I, {
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"])
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset ? (l(), V(w, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: h.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: i.$refs.chart,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip
    }, Re({ _: 2 }, [
      i.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: z(() => [
          O(i.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      i.$slots.optionPdf ? {
        name: "optionPdf",
        fn: z(() => [
          O(i.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      i.$slots.optionCsv ? {
        name: "optionCsv",
        fn: z(() => [
          O(i.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      i.$slots.optionImg ? {
        name: "optionImg",
        fn: z(() => [
          O(i.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      i.$slots.optionTable ? {
        name: "optionTable",
        fn: z(() => [
          O(i.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      i.$slots.optionLabels ? {
        name: "optionLabels",
        fn: z(() => [
          O(i.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      i.$slots.optionStack ? {
        name: "optionStack",
        fn: z(() => [
          O(i.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      i.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: z(({ toggleFullscreen: a, isFullscreen: o }) => [
          O(i.$slots, "optionFullscreen", B(Y({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
        ]),
        key: "7"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "isTooltip", "titles", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip"])) : c("", !0),
    e.isDataset ? (l(), r("svg", {
      key: 2,
      xmlns: "http://www.w3.org/2000/svg",
      class: p([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: A(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      e.maxSeries > 0 ? (l(), r("g", Ze, [
        u("g", Ue, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (l(), r("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, Je)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (l(!0), r(m, { key: 2 }, b(e.allScales, (a) => (l(), r("g", null, [
            a.id === t.selectedScale && a.yLabels.length ? (l(!0), r(m, { key: 0 }, b(a.yLabels, (o) => (l(), r("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(o.y),
              y2: e.checkNaN(o.y),
              stroke: a.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, $e))), 256)) : a.yLabels.length ? (l(!0), r(m, { key: 1 }, b(a.yLabels, (o) => (l(), r("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(o.y),
              y2: e.checkNaN(o.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, et))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (l(), r(m, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (l(), r("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, Ke)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (l(), r("g", Qe, [
              (l(!0), r(m, null, b(e.yLabels, (a) => (l(), r("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.checkNaN(a.y),
                y2: e.checkNaN(a.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, je))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (l(), r("g", tt, [
            (l(!0), r(m, null, b(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (a, o) => (l(), r("line", {
              key: `grid_vertical_line_${o}`,
              x1: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, at))), 128))
          ])) : c("", !0)
        ]),
        (l(!0), r(m, null, b(e.barSet, (a, o) => (l(), r("defs", {
          key: `def_rect_${o}`
        }, [
          u("linearGradient", {
            id: `rectGradient_pos_${o}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": a.color
            }, null, 8, lt),
            u("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}DE`
            }, null, 8, rt),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}66`
            }, null, 8, st)
          ], 8, it),
          u("linearGradient", {
            id: `rectGradient_neg_${o}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}66`
            }, null, 8, ot),
            u("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}DE`
            }, null, 8, ct),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, ht)
          ], 8, nt)
        ]))), 128)),
        (l(!0), r(m, null, b(e.plotSet, (a, o) => (l(), r("defs", {
          key: `def_plot_${o}`
        }, [
          u("radialGradient", {
            id: `plotGradient_${o}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, ut),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, gt)
          ], 8, dt)
        ]))), 128)),
        (l(!0), r(m, null, b(e.lineSet, (a, o) => (l(), r("defs", {
          key: `def_line_${o}`
        }, [
          u("radialGradient", {
            id: `lineGradient_${o}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, mt),
            u("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, Nt)
          ], 8, ft),
          u("linearGradient", {
            id: `areaGradient_${o}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.03)}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, bt),
            u("stop", {
              offset: "100%",
              "stop-color": `${a.color}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, xt)
          ], 8, It)
        ]))), 128)),
        (l(!0), r(m, null, b(e.highlightAreas, (a) => (l(), r("g", null, [
          a.show ? (l(), r(m, { key: 0 }, [
            u("rect", {
              style: { transition: "none" },
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries * a.span < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries * a.span,
              fill: `${a.color}${t.opacity[a.opacity]}`
            }, null, 8, _t),
            a.caption.text ? (l(), r("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from - t.slicer.start) - (a.caption.width === "auto" ? 0 : a.caption.width / 2 - e.drawingArea.width / e.maxSeries * a.span / 2),
              y: e.drawingArea.top + a.caption.offsetY,
              style: { overflow: "visible" },
              height: "1",
              width: a.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * a.span : a.caption.width
            }, [
              u("div", {
                style: A(`padding:${a.caption.padding}px;text-align:${a.caption.textAlign};font-size:${a.caption.fontSize}px;color:${a.caption.color};font-weight:${a.caption.bold ? "bold" : "normal"}`)
              }, k(a.caption.text), 5)
            ], 8, Ft)) : c("", !0)
          ], 64)) : c("", !0)
        ]))), 256)),
        u("g", null, [
          (l(!0), r(m, null, b(e.maxSeries, (a, o) => (l(), r("g", {
            key: `tooltip_trap_${o}`
          }, [
            u("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(o) ? `${e.FINAL_CONFIG.chart.highlighter.color}${t.opacity[e.FINAL_CONFIG.chart.highlighter.opacity]}` : "transparent"
            }, null, 8, yt)
          ]))), 128))
        ]),
        e.barSet.length ? (l(!0), r(m, { key: 0 }, b(e.barSet, (a, o) => (l(), r("g", {
          key: `serie_bar_${o}`,
          class: p(`serie_bar_${o}`),
          style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `bar_plot_${o}_${g}`
          }, [
            e.canShowValue(n.value) ? (l(), r("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${o}_${t.uniqueId})` : `url(#rectGradient_neg_${o}_${t.uniqueId})` : a.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? a.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, At)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), r("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              O(i.$slots, "plot-comment", {
                plot: { ...n, color: a.color }
              }, void 0, !0)
            ], 8, Lt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (l(), r("g", kt, [
            u("defs", null, [
              u("marker", {
                id: `bar_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, Ct)
              ], 8, St)
            ]),
            a.plots.length > 1 ? (l(), r("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${o})`
            }, null, 8, wt)) : c("", !0),
            a.plots.length > 1 ? (l(), r("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Ot)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (l(), r("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, vt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || t.selectedMinimapIndex !== null) ? (l(), r("g", Gt, [
          u("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (t.selectedSerieIndex || t.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (t.selectedSerieIndex || t.selectedMinimapIndex) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, zt)
        ])) : c("", !0),
        u("g", null, [
          u("rect", {
            style: { transition: "none" },
            x: 0,
            y: e.drawingArea.top,
            width: e.FINAL_CONFIG.chart.padding.left - 1 + e.xPadding,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            fill: e.FINAL_CONFIG.chart.backgroundColor
          }, null, 8, Mt),
          u("rect", {
            style: { transition: "none" },
            x: e.drawingArea.right + 1 - e.xPadding,
            y: e.drawingArea.top,
            width: e.FINAL_CONFIG.chart.padding.right - 1 + e.xPadding,
            height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
            fill: e.FINAL_CONFIG.chart.backgroundColor
          }, null, 8, pt)
        ]),
        e.FINAL_CONFIG.chart.grid.frame.show ? (l(), r("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Pt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (l(), r("g", Tt, [
          t.mutableConfig.useIndividualScale ? (l(), r(m, { key: 0 }, [
            (l(!0), r(m, null, b(e.allScales, (a) => (l(), r("g", null, [
              u("line", {
                x1: a.x + e.xPadding,
                x2: a.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset - a.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Vt)
            ]))), 256)),
            (l(!0), r(m, null, b(e.allScales, (a) => (l(), r("g", {
              style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              u("text", {
                fill: a.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset - a.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, k(a.name) + " " + k(a.scaleLabel ? `- ${a.scaleLabel}` : ""), 9, Rt),
              (l(!0), r(m, null, b(a.yLabels, (o, n) => (l(), r("line", {
                x1: a.x - 3 + e.xPadding,
                x2: a.x + e.xPadding,
                y1: e.checkNaN(o.y),
                y2: e.checkNaN(o.y),
                stroke: a.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Dt))), 256)),
              (l(!0), r(m, null, b(a.yLabels, (o, n) => (l(), r("text", {
                x: a.x - 5 + e.xPadding,
                y: e.checkNaN(o.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: a.color
              }, k(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                o.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: o.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: 1
                })
              )), 9, Ht))), 256))
            ], 4))), 256))
          ], 64)) : (l(!0), r(m, { key: 1 }, b(e.yLabels, (a, o) => (l(), r("g", {
            key: `yLabel_${o}`
          }, [
            e.canShowValue(a) && a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (l(), r("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(a.y),
              y2: e.checkNaN(a.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Et)) : c("", !0),
            a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (l(), r("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(a.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, k(e.canShowValue(a.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              a.value,
              e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: a.value,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: 1
              })
            ) : ""), 9, Wt)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (l(!0), r(m, null, b(e.plotSet, (a, o) => (l(), r("g", {
          key: `serie_plot_${o}`,
          class: p(`serie_plot_${o}`),
          style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `circle_plot_${o}_${g}`
          }, [
            e.canShowValue(n.value) ? (l(), V(L, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${o}_${t.uniqueId})` : a.color,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.chart.backgroundColor,
              strokeWidth: 0.5
            }, null, 8, ["shape", "color", "plot", "radius", "stroke"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), r("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", Yt, [
                O(i.$slots, "plot-comment", {
                  plot: { ...n, color: a.color }
                }, void 0, !0)
              ])
            ], 8, Bt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (l(), r("g", Xt, [
            u("defs", null, [
              u("marker", {
                id: `plot_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, Zt)
              ], 8, qt)
            ]),
            a.plots.length > 1 ? (l(), r("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${o})`
            }, null, 8, Ut)) : c("", !0),
            a.plots.length > 1 ? (l(), r("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Jt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (l(!0), r(m, null, b(e.lineSet, (a, o) => (l(), r("g", {
          key: `serie_line_${o}`,
          class: p(`serie_line_${o}`),
          style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.smooth && a.plots.length > 1 ? (l(), r("path", {
            key: 0,
            d: `M${a.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Kt)) : a.plots.length > 1 ? (l(), r("g", Qt, [
            (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `line_${o}_${g}`
            }, [
              n && g < a.plots.length - 1 && a.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[g + 1].value) ? (l(), r("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[g + 1].x,
                y1: n.y,
                y2: a.plots[g + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, jt)) : c("", !0)
            ]))), 128))
          ])) : c("", !0)
        ], 6))), 128)),
        (l(!0), r(m, null, b(e.lineSet, (a, o) => (l(), r("g", {
          key: `serie_line_${o}`,
          class: p(`serie_line_${o}`),
          style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.useArea && a.plots.length > 1 ? (l(), r("g", $t, [
            a.smooth ? (l(), r("path", {
              key: 0,
              d: `M ${a.plots[0] ? a.plots[0].x : Math.min(...a.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} ${a.curve} L ${a.plots.at(-1) ? a.plots.at(-1).x : e.drawingArea.left + e.slot.line * o + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${t.uniqueId})` : `${a.color}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, ea)) : (l(), r("path", {
              key: 1,
              d: `M${a.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${t.uniqueId})` : `${a.color}${t.opacity[e.FINAL_CONFIG.line.area.opacity]}`
            }, null, 8, ta))
          ])) : c("", !0),
          a.smooth && a.plots.length > 1 ? (l(), r("path", {
            key: 1,
            d: `M${a.curve}`,
            stroke: a.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, aa)) : a.plots.length > 1 ? (l(), r("g", ia, [
            (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `line_${o}_${g}`
            }, [
              n && g < a.plots.length - 1 && a.plots[g + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[g + 1].value) ? (l(), r("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[g + 1].x,
                y1: n.y,
                y2: a.plots[g + 1].y,
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, la)) : c("", !0)
            ]))), 128))
          ])) : c("", !0),
          (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `circle_line_${o}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (l(), V(L, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${o}_${t.uniqueId})` : a.color,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.chart.backgroundColor,
              strokeWidth: 0.5
            }, null, 8, ["shape", "color", "plot", "radius", "stroke"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), r("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", sa, [
                O(i.$slots, "plot-comment", {
                  plot: { ...n, color: a.color }
                }, void 0, !0)
              ])
            ], 8, ra)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (l(), r("g", na, [
            u("defs", null, [
              u("marker", {
                id: `line_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, ca)
              ], 8, oa)
            ]),
            a.plots.length > 1 ? (l(), r("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${o})`
            }, null, 8, ha)) : c("", !0),
            a.plots.length > 1 ? (l(), r("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, da)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (l(), r("g", ua, [
          (l(!0), r(m, null, b(e.barSet, (a, o) => (l(), r("g", {
            key: `xLabel_bar_${o}`,
            class: p(`xLabel_bar_${o}`),
            style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `xLabel_bar_${o}_${g}`
            }, [
              n && (!Object.hasOwn(a, "dataLabels") || a.dataLabels === !0) && e.FINAL_CONFIG.bar.labels.show ? (l(), r("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value > 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, ga)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (l(), r("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? a.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, k(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: a.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : a.name), 9, fa)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (l(), r("g", ma, [
          (l(!0), r(m, null, b(e.plotSet, (a, o) => (l(), r("g", {
            key: `xLabel_plot_${o}`,
            class: p(`xLabel_plot_${o}`),
            style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `xLabel_plot_${o}_${g}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 ? (l(), r("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, Na)) : c("", !0),
              n && g === 0 && a.useTag && a.useTag === "start" ? (l(), r("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(a.name), 5)
              ], 8, Ia)) : c("", !0),
              n && g === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (l(), r("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(a.name), 5)
              ], 8, ba)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (l(), r("g", xa, [
          (l(!0), r(m, null, b(e.lineSet, (a, o) => (l(), r("g", {
            key: `xLabel_line_${o}`,
            class: p(`xLabel_line_${o}`),
            style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
              key: `xLabel_line_${o}_${g}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 ? (l(), r("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, _a)) : c("", !0),
              n && g === 0 && a.useTag && a.useTag === "start" ? (l(), r("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(a.name), 5)
              ], 8, Fa)) : c("", !0),
              n && g === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (l(), r("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: A(`padding: 3px; background:${a.color}${t.opacity[80]};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(a.name), 5)
              ], 8, ya)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (l(!0), r(m, null, b(e.lineSet, (a, o) => (l(), r("g", {
          key: `xLabel_line_${o}`,
          class: p(`xLabel_line_${o}`),
          style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `xLabel_line_${o}_${g}`
          }, [
            n && g === 0 && a.showSerieName && a.showSerieName === "start" ? (l(), r("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Aa)) : c("", !0),
            n && g === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (l(), r("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, La)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (l(!0), r(m, null, b(e.plotSet, (a, o) => (l(), r("g", {
          key: `xLabel_plot_${o}`,
          class: p(`xLabel_plot_${o}`),
          style: A(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), r(m, null, b(a.plots, (n, g) => (l(), r("g", {
            key: `xLabel_plot_${o}_${g}`
          }, [
            n && g === 0 && a.showSerieName && a.showSerieName === "start" ? (l(), r("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ka)) : c("", !0),
            n && g === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (l(), r("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Sa)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (l(!0), r(m, { key: 8 }, b(e.allScales, (a) => (l(), r("rect", {
          x: a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === a.id ? `${a.color}20` : "transparent",
          onMouseenter: (o) => t.selectedScale = a.id,
          onMouseleave: s[0] || (s[0] = (o) => t.selectedScale = null)
        }, null, 40, Ca))), 256)) : c("", !0),
        u("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (l(), r("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, k(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, wa)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (l(), r("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, k(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Oa)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (l(), r("g", va, [
          (l(!0), r(m, null, b(e.timeLabels, (a, o) => (l(), r("g", {
            key: `time_label_${o}`
          }, [
            a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (o === 0 || o === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === o && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && o % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (l(), r("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * o + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`
            }, k(a || ""), 9, Ga)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        u("g", null, [
          (l(!0), r(m, null, b(e.maxSeries, (a, o) => (l(), r("g", {
            key: `tooltip_trap_${o}`
          }, [
            u("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, o),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(o)
            }, null, 40, za)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && ![null, void 0].includes(t.selectedSerieIndex) ? (l(), r("g", Ma, [
          (l(), r("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * t.selectedSerieIndex - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            u("div", {
              class: "vue-ui-xy-time-tag",
              style: A(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, k(e.timeLabels[t.selectedSerieIndex] || t.selectedSerieIndex), 5)
          ], 8, pa)),
          u("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * t.selectedSerieIndex + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Pa)
        ])) : c("", !0)
      ])) : c("", !0),
      O(i.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, qe)) : c("", !0),
    i.$slots.watermark ? (l(), r("div", Ta, [
      O(i.$slots, "watermark", B(Y({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (l(), V(N, {
      key: 4,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (l(), V(y, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (a) => t.slicer.start = a),
      end: t.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (a) => t.slicer.end = a),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": z(({ reset: a }) => [
        O(i.$slots, "reset-action", B(Y({ reset: a })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (l(), r("div", {
      key: 6,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: A(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (l(!0), r(m, null, b(e.absoluteDataset, (a, o) => (l(), r("div", {
        key: `div_legend_item_${o}`,
        onClick: (n) => e.segregate(a),
        class: p({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(a.id) })
      }, [
        t.icons[a.type] === "line" ? (l(), r("svg", Ra, [
          u("rect", {
            x: "0",
            y: "7",
            rx: "3",
            stroke: "none",
            height: "4",
            width: "20",
            fill: a.color
          }, null, 8, Da),
          X(L, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 1
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (l(), r("svg", Ha, [
          t.icons[a.type] === "bar" ? (l(), r("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: a.color
          }, null, 8, Ea)) : (l(), V(L, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        u("span", {
          style: A(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, k(a.name), 5)
      ], 10, Va))), 128))
    ], 4)) : (l(), r("div", Wa, [
      O(i.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    X(M, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: i.$refs.chart,
      content: e.tooltipContent,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": z(() => [
        O(i.$slots, "tooltip-before", B(Y({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": z(() => [
        O(i.$slots, "tooltip-after", B(Y({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
    e.isDataset ? (l(), V(x, {
      key: 8,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: z(() => [
        u("div", {
          style: A(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          u("div", Ba, [
            De(u("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (a) => t.showSparklineTable = a)
            }, null, 512), [
              [He, t.showSparklineTable]
            ]),
            u("div", {
              onClick: s[5] || (s[5] = (a) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              X(S, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (l(), V(G, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (l(), V(v, {
            key: 1,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (a) => t.mutableConfig.showTable = !1)
          }, {
            th: z(({ th: a }) => [
              u("div", { innerHTML: a }, null, 8, Ya)
            ]),
            td: z(({ td: a }) => [
              Ee(k(isNaN(Number(a)) ? a : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: a,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 14, Xe);
}
const ni = /* @__PURE__ */ We(Ye, [["render", Xa], ["__scopeId", "data-v-19f5eb68"]]);
export {
  ni as default
};
